import ctypes
import enum
import typing
from typing import Any

class _UniffiRustBuffer(ctypes.Structure):
    @staticmethod
    def alloc(size: Any): ...
    @staticmethod
    def reserve(rbuf: Any, additional: Any): ...
    def free(self): ...
    def alloc_with_builder(*args: Any) -> None: ...
    def consume_with_stream(self) -> None: ...
    def read_with_stream(self) -> None: ...

class _UniffiForeignBytes(ctypes.Structure): ...

class _UniffiRustBufferStream:
    data: Any = ...
    len: Any = ...
    offset: int = ...
    def __init__(self, data: Any, len: Any) -> None: ...
    @classmethod
    def from_rust_buffer(cls, buf: Any): ...
    def remaining(self): ...
    def read(self, size: Any): ...
    def read_i8(self): ...
    def read_u8(self): ...
    def read_i16(self): ...
    def read_u16(self): ...
    def read_i32(self): ...
    def read_u32(self): ...
    def read_i64(self): ...
    def read_u64(self): ...
    def read_float(self): ...
    def read_double(self): ...
    def read_c_size_t(self): ...

class _UniffiRustBufferBuilder:
    rbuf: Any = ...
    def __init__(self) -> None: ...
    def finalize(self): ...
    def discard(self) -> None: ...
    def write(self, value: Any) -> None: ...
    def write_i8(self, v: Any) -> None: ...
    def write_u8(self, v: Any) -> None: ...
    def write_i16(self, v: Any) -> None: ...
    def write_u16(self, v: Any) -> None: ...
    def write_i32(self, v: Any) -> None: ...
    def write_u32(self, v: Any) -> None: ...
    def write_i64(self, v: Any) -> None: ...
    def write_u64(self, v: Any) -> None: ...
    def write_float(self, v: Any) -> None: ...
    def write_double(self, v: Any) -> None: ...
    def write_c_size_t(self, v: Any) -> None: ...

class InternalError(Exception): ...

class _UniffiRustCallStatus(ctypes.Structure):
    CALL_SUCCESS: int = ...
    CALL_ERROR: int = ...
    CALL_PANIC: int = ...

class _UniffiPointerManagerCPython:
    def new_pointer(self, obj: Any): ...
    def release_pointer(self, address: Any): ...
    def lookup(self, address: Any): ...

class _UniffiPointerManagerGeneral:
    def __init__(self) -> None: ...
    def new_pointer(self, obj: Any): ...
    def release_pointer(self, handle: Any): ...
    def lookup(self, handle: Any): ...

class _UniffiConverterPrimitive:
    @classmethod
    def check(cls, value: Any): ...
    @classmethod
    def lift(cls, value: Any): ...
    @classmethod
    def lower(cls, value: Any): ...
    @classmethod
    def lowerUnchecked(cls, value: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...

class _UniffiConverterPrimitiveInt(_UniffiConverterPrimitive):
    @classmethod
    def check(cls, value: Any): ...

class _UniffiConverterPrimitiveFloat(_UniffiConverterPrimitive):
    @classmethod
    def check(cls, value: Any): ...

class _UniffiConverterRustBuffer:
    @classmethod
    def lift(cls, rbuf: Any): ...
    @classmethod
    def lower(cls, value: Any): ...

class _UniffiConverterUInt8(_UniffiConverterPrimitiveInt):
    CLASS_NAME: str = ...
    VALUE_MIN: int = ...
    VALUE_MAX: Any = ...
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write_unchecked(value: Any, buf: Any) -> None: ...

class _UniffiConverterInt8(_UniffiConverterPrimitiveInt):
    CLASS_NAME: str = ...
    VALUE_MIN: Any = ...
    VALUE_MAX: Any = ...
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write_unchecked(value: Any, buf: Any) -> None: ...

class _UniffiConverterUInt16(_UniffiConverterPrimitiveInt):
    CLASS_NAME: str = ...
    VALUE_MIN: int = ...
    VALUE_MAX: Any = ...
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write_unchecked(value: Any, buf: Any) -> None: ...

class _UniffiConverterInt16(_UniffiConverterPrimitiveInt):
    CLASS_NAME: str = ...
    VALUE_MIN: Any = ...
    VALUE_MAX: Any = ...
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write_unchecked(value: Any, buf: Any) -> None: ...

class _UniffiConverterUInt32(_UniffiConverterPrimitiveInt):
    CLASS_NAME: str = ...
    VALUE_MIN: int = ...
    VALUE_MAX: Any = ...
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write_unchecked(value: Any, buf: Any) -> None: ...

class _UniffiConverterInt32(_UniffiConverterPrimitiveInt):
    CLASS_NAME: str = ...
    VALUE_MIN: Any = ...
    VALUE_MAX: Any = ...
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write_unchecked(value: Any, buf: Any) -> None: ...

class _UniffiConverterUInt64(_UniffiConverterPrimitiveInt):
    CLASS_NAME: str = ...
    VALUE_MIN: int = ...
    VALUE_MAX: Any = ...
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write_unchecked(value: Any, buf: Any) -> None: ...

class _UniffiConverterInt64(_UniffiConverterPrimitiveInt):
    CLASS_NAME: str = ...
    VALUE_MIN: Any = ...
    VALUE_MAX: Any = ...
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write_unchecked(value: Any, buf: Any) -> None: ...

class _UniffiConverterBool(_UniffiConverterPrimitive):
    @classmethod
    def check(cls, value: Any): ...
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write_unchecked(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...

class _UniffiConverterString:
    @staticmethod
    def check(value: Any): ...
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(buf: Any): ...
    @staticmethod
    def lower(value: Any): ...

class _UniffiConverterBytes(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class AccessRule:
    def __del__(self) -> None: ...
    @classmethod
    def allow_all(cls): ...
    @classmethod
    def deny_all(cls): ...
    @classmethod
    def require(cls: Any, resource_or_non_fungible: ResourceOrNonFungible) -> Any: ...
    @classmethod
    def require_all_of(
        cls: Any, resources: typing.List[ResourceOrNonFungible]
    ) -> Any: ...
    @classmethod
    def require_amount(cls: Any, amount: Decimal, resource: Address) -> Any: ...
    @classmethod
    def require_any_of(
        cls: Any, resources: typing.List[ResourceOrNonFungible]
    ) -> Any: ...
    @classmethod
    def require_count_of(
        cls: Any, count: int, resources: typing.List[ResourceOrNonFungible]
    ) -> Any: ...
    @classmethod
    def require_virtual_signature(cls: Any, public_key: PublicKey) -> Any: ...

class _UniffiConverterTypeAccessRule:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class Address:
    def __init__(self, address: str) -> Any: ...
    def __del__(self) -> None: ...
    @classmethod
    def from_raw(cls: Any, node_id_bytes: bytes, network_id: int) -> Any: ...
    @classmethod
    def resource_address_from_olympia_resource_address(
        cls: Any, olympia_resource_address: OlympiaAddress, network_id: int
    ) -> Any: ...
    @classmethod
    def virtual_account_address_from_olympia_address(
        cls: Any, olympia_account_address: OlympiaAddress, network_id: int
    ) -> Any: ...
    @classmethod
    def virtual_account_address_from_public_key(
        cls: Any, public_key: PublicKey, network_id: int
    ) -> Any: ...
    @classmethod
    def virtual_identity_address_from_public_key(
        cls: Any, public_key: PublicKey, network_id: int
    ) -> Any: ...
    def address_string(self) -> str: ...
    def as_str(self) -> str: ...
    def bytes(self) -> bytes: ...
    def entity_type(self) -> EntityType: ...
    def is_global(self) -> bool: ...
    def is_global_component(self) -> bool: ...
    def is_global_consensus_manager(self) -> bool: ...
    def is_global_fungible_resource_manager(self) -> bool: ...
    def is_global_non_fungible_resource_manager(self) -> bool: ...
    def is_global_package(self) -> bool: ...
    def is_global_resource_manager(self) -> bool: ...
    def is_global_virtual(self) -> bool: ...
    def is_internal(self) -> bool: ...
    def is_internal_fungible_vault(self) -> bool: ...
    def is_internal_kv_store(self) -> bool: ...
    def is_internal_non_fungible_vault(self) -> bool: ...
    def is_internal_vault(self) -> bool: ...
    def network_id(self) -> int: ...

class _UniffiConverterTypeAddress:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class Decimal:
    def __init__(self, value: str) -> Any: ...
    def __del__(self) -> None: ...
    @classmethod
    def max(cls): ...
    @classmethod
    def min(cls): ...
    @classmethod
    def one(cls): ...
    @classmethod
    def zero(cls): ...
    def abs(self) -> Decimal: ...
    def add(self, other: Decimal) -> Decimal: ...
    def as_str(self) -> str: ...
    def cbrt(self) -> Decimal: ...
    def ceiling(self) -> Decimal: ...
    def div(self, other: Decimal) -> Decimal: ...
    def equal(self, other: Decimal) -> bool: ...
    def floor(self) -> Decimal: ...
    def greater_than(self, other: Decimal) -> bool: ...
    def greater_than_or_equal(self, other: Decimal) -> bool: ...
    def is_negative(self) -> bool: ...
    def is_positive(self) -> bool: ...
    def is_zero(self) -> bool: ...
    def less_than(self, other: Decimal) -> bool: ...
    def less_than_or_equal(self, other: Decimal) -> bool: ...
    def mantissa(self) -> str: ...
    def mul(self, other: Decimal) -> Decimal: ...
    def not_equal(self, other: Decimal) -> bool: ...
    def nth_root(self, n: int) -> typing.Optional[Decimal]: ...
    def powi(self, exp: int) -> Decimal: ...
    def round(self, decimal_places: int, rounding_mode: RoundingMode) -> Decimal: ...
    def sqrt(self) -> typing.Optional[Decimal]: ...
    def sub(self, other: Decimal) -> Decimal: ...

class _UniffiConverterTypeDecimal:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class Hash:
    def __init__(self, hash: bytes) -> Any: ...
    def __del__(self) -> None: ...
    @classmethod
    def from_hex_string(cls: Any, hash: str) -> Any: ...
    @classmethod
    def from_unhashed_bytes(cls: Any, bytes: bytes) -> Any: ...
    @classmethod
    def sbor_decode(cls: Any, bytes: bytes) -> Any: ...
    def as_str(self) -> str: ...
    def bytes(self) -> bytes: ...

class _UniffiConverterTypeHash:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class Instructions:
    def __del__(self) -> None: ...
    @classmethod
    def from_instructions(
        cls: Any, instructions: typing.List[Instruction], network_id: int
    ) -> Any: ...
    @classmethod
    def from_string(cls: Any, string: str, network_id: int) -> Any: ...
    def as_str(self) -> str: ...
    def instructions_list(self) -> typing.List[Instruction]: ...
    def network_id(self) -> int: ...

class _UniffiConverterTypeInstructions:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class Intent:
    def __init__(
        self, header: TransactionHeader, manifest: TransactionManifest, message: Message
    ) -> Any: ...
    def __del__(self) -> None: ...
    @classmethod
    def decompile(cls: Any, compiled_intent: bytes) -> Any: ...
    def compile(self) -> bytes: ...
    def hash(self) -> TransactionHash: ...
    def header(self) -> TransactionHeader: ...
    def intent_hash(self) -> TransactionHash: ...
    def manifest(self) -> TransactionManifest: ...
    def message(self) -> Message: ...
    def statically_validate(self, validation_config: ValidationConfig) -> Any: ...

class _UniffiConverterTypeIntent:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class ManifestBuilder:
    def __init__(self) -> None: ...
    def __del__(self) -> None: ...
    def access_controller_cancel_primary_role_badge_withdraw_attempt(
        self, address: Address
    ) -> ManifestBuilder: ...
    def access_controller_cancel_primary_role_recovery_proposal(
        self, address: Address
    ) -> ManifestBuilder: ...
    def access_controller_cancel_recovery_role_badge_withdraw_attempt(
        self, address: Address
    ) -> ManifestBuilder: ...
    def access_controller_cancel_recovery_role_recovery_proposal(
        self, address: Address
    ) -> ManifestBuilder: ...
    def access_controller_create(
        self,
        controlled_asset: ManifestBuilderBucket,
        rule_set: RuleSet,
        timed_recovery_delay_in_minutes: typing.Optional[int],
        address_reservation: typing.Optional[ManifestBuilderAddressReservation],
    ) -> ManifestBuilder: ...
    def access_controller_create_proof(self, address: Address) -> ManifestBuilder: ...
    def access_controller_create_with_security_structure(
        self,
        controlled_asset: ManifestBuilderBucket,
        primary_role: SecurityStructureRole,
        recovery_role: SecurityStructureRole,
        confirmation_role: SecurityStructureRole,
        timed_recovery_delay_in_minutes: typing.Optional[int],
        address_reservation: typing.Optional[ManifestBuilderAddressReservation],
    ) -> ManifestBuilder: ...
    def access_controller_initiate_badge_withdraw_as_primary(
        self, address: Address
    ) -> ManifestBuilder: ...
    def access_controller_initiate_badge_withdraw_as_recovery(
        self, address: Address
    ) -> ManifestBuilder: ...
    def access_controller_initiate_recovery_as_primary(
        self,
        address: Address,
        rule_set: RuleSet,
        timed_recovery_delay_in_minutes: typing.Optional[int],
    ) -> ManifestBuilder: ...
    def access_controller_initiate_recovery_as_recovery(
        self,
        address: Address,
        rule_set: RuleSet,
        timed_recovery_delay_in_minutes: typing.Optional[int],
    ) -> ManifestBuilder: ...
    def access_controller_lock_primary_role(
        self, address: Address
    ) -> ManifestBuilder: ...
    def access_controller_mint_recovery_badges(
        self, address: Address, non_fungible_local_ids: typing.List[NonFungibleLocalId]
    ) -> ManifestBuilder: ...
    def access_controller_new_from_public_keys(
        self,
        controlled_asset: ManifestBuilderBucket,
        primary_role: PublicKey,
        recovery_role: PublicKey,
        confirmation_role: PublicKey,
        timed_recovery_delay_in_minutes: typing.Optional[int],
        address_reservation: typing.Optional[ManifestBuilderAddressReservation],
    ) -> ManifestBuilder: ...
    def access_controller_quick_confirm_primary_role_badge_withdraw_attempt(
        self, address: Address
    ) -> ManifestBuilder: ...
    def access_controller_quick_confirm_primary_role_recovery_proposal(
        self,
        address: Address,
        rule_set: RuleSet,
        timed_recovery_delay_in_minutes: typing.Optional[int],
    ) -> ManifestBuilder: ...
    def access_controller_quick_confirm_recovery_role_badge_withdraw_attempt(
        self, address: Address
    ) -> ManifestBuilder: ...
    def access_controller_quick_confirm_recovery_role_recovery_proposal(
        self,
        address: Address,
        rule_set: RuleSet,
        timed_recovery_delay_in_minutes: typing.Optional[int],
    ) -> ManifestBuilder: ...
    def access_controller_stop_timed_recovery(
        self,
        address: Address,
        rule_set: RuleSet,
        timed_recovery_delay_in_minutes: typing.Optional[int],
    ) -> ManifestBuilder: ...
    def access_controller_timed_confirm_recovery(
        self,
        address: Address,
        rule_set: RuleSet,
        timed_recovery_delay_in_minutes: typing.Optional[int],
    ) -> ManifestBuilder: ...
    def access_controller_unlock_primary_role(
        self, address: Address
    ) -> ManifestBuilder: ...
    def account_add_authorized_depositor(
        self, address: Address, badge: ResourceOrNonFungible
    ) -> ManifestBuilder: ...
    def account_burn(
        self, address: Address, resource_address: Address, amount: Decimal
    ) -> ManifestBuilder: ...
    def account_burn_non_fungibles(
        self,
        address: Address,
        resource_address: Address,
        ids: typing.List[NonFungibleLocalId],
    ) -> ManifestBuilder: ...
    def account_create(self) -> ManifestBuilder: ...
    def account_create_advanced(
        self,
        owner_role: OwnerRole,
        address_reservation: typing.Optional[ManifestBuilderAddressReservation],
    ) -> ManifestBuilder: ...
    def account_create_proof_of_amount(
        self, address: Address, resource_address: Address, amount: Decimal
    ) -> ManifestBuilder: ...
    def account_create_proof_of_non_fungibles(
        self,
        address: Address,
        resource_address: Address,
        ids: typing.List[NonFungibleLocalId],
    ) -> ManifestBuilder: ...
    def account_deposit(
        self, address: Address, bucket: ManifestBuilderBucket
    ) -> ManifestBuilder: ...
    def account_deposit_batch(
        self, address: Address, buckets: typing.List[ManifestBuilderBucket]
    ) -> ManifestBuilder: ...
    def account_deposit_entire_worktop(
        self, account_address: Address
    ) -> ManifestBuilder: ...
    def account_lock_contingent_fee(
        self, address: Address, amount: Decimal
    ) -> ManifestBuilder: ...
    def account_lock_fee(
        self, address: Address, amount: Decimal
    ) -> ManifestBuilder: ...
    def account_lock_fee_and_withdraw(
        self,
        address: Address,
        amount_to_lock: Decimal,
        resource_address: Address,
        amount: Decimal,
    ) -> ManifestBuilder: ...
    def account_lock_fee_and_withdraw_non_fungibles(
        self,
        address: Address,
        amount_to_lock: Decimal,
        resource_address: Address,
        ids: typing.List[NonFungibleLocalId],
    ) -> ManifestBuilder: ...
    def account_remove_authorized_depositor(
        self, address: Address, badge: ResourceOrNonFungible
    ) -> ManifestBuilder: ...
    def account_remove_resource_preference(
        self, address: Address, resource_address: Address
    ) -> ManifestBuilder: ...
    def account_securify(self, address: Address) -> ManifestBuilder: ...
    def account_set_default_deposit_rule(
        self, address: Address, default_deposit_rule: AccountDefaultDepositRule
    ) -> ManifestBuilder: ...
    def account_set_resource_preference(
        self,
        address: Address,
        resource_address: Address,
        resource_preference: ResourcePreference,
    ) -> ManifestBuilder: ...
    def account_try_deposit_batch_or_abort(
        self,
        address: Address,
        buckets: typing.List[ManifestBuilderBucket],
        authorized_depositor_badge: typing.Optional[ResourceOrNonFungible],
    ) -> ManifestBuilder: ...
    def account_try_deposit_batch_or_refund(
        self,
        address: Address,
        buckets: typing.List[ManifestBuilderBucket],
        authorized_depositor_badge: typing.Optional[ResourceOrNonFungible],
    ) -> ManifestBuilder: ...
    def account_try_deposit_entire_worktop_or_abort(
        self,
        account_address: Address,
        authorized_depositor_badge: typing.Optional[ResourceOrNonFungible],
    ) -> ManifestBuilder: ...
    def account_try_deposit_entire_worktop_or_refund(
        self,
        account_address: Address,
        authorized_depositor_badge: typing.Optional[ResourceOrNonFungible],
    ) -> ManifestBuilder: ...
    def account_try_deposit_or_abort(
        self,
        address: Address,
        bucket: ManifestBuilderBucket,
        authorized_depositor_badge: typing.Optional[ResourceOrNonFungible],
    ) -> ManifestBuilder: ...
    def account_try_deposit_or_refund(
        self,
        address: Address,
        bucket: ManifestBuilderBucket,
        authorized_depositor_badge: typing.Optional[ResourceOrNonFungible],
    ) -> ManifestBuilder: ...
    def account_withdraw(
        self, address: Address, resource_address: Address, amount: Decimal
    ) -> ManifestBuilder: ...
    def account_withdraw_non_fungibles(
        self,
        address: Address,
        resource_address: Address,
        ids: typing.List[NonFungibleLocalId],
    ) -> ManifestBuilder: ...
    def allocate_global_address(
        self,
        package_address: Address,
        blueprint_name: str,
        into_address_reservation: ManifestBuilderAddressReservation,
        into_named_address: ManifestBuilderNamedAddress,
    ) -> ManifestBuilder: ...
    def assert_worktop_contains(
        self, resource_address: Address, amount: Decimal
    ) -> ManifestBuilder: ...
    def assert_worktop_contains_any(
        self, resource_address: Address
    ) -> ManifestBuilder: ...
    def assert_worktop_contains_non_fungibles(
        self, resource_address: Address, ids: typing.List[NonFungibleLocalId]
    ) -> ManifestBuilder: ...
    def build(self, network_id: int) -> TransactionManifest: ...
    def burn_resource(self, bucket: ManifestBuilderBucket) -> ManifestBuilder: ...
    def call_access_rules_method(
        self,
        address: ManifestBuilderAddress,
        method_name: str,
        args: typing.List[ManifestBuilderValue],
    ) -> ManifestBuilder: ...
    def call_direct_vault_method(
        self,
        address: Address,
        method_name: str,
        args: typing.List[ManifestBuilderValue],
    ) -> ManifestBuilder: ...
    def call_function(
        self,
        address: ManifestBuilderAddress,
        blueprint_name: str,
        function_name: str,
        args: typing.List[ManifestBuilderValue],
    ) -> ManifestBuilder: ...
    def call_metadata_method(
        self,
        address: ManifestBuilderAddress,
        method_name: str,
        args: typing.List[ManifestBuilderValue],
    ) -> ManifestBuilder: ...
    def call_method(
        self,
        address: ManifestBuilderAddress,
        method_name: str,
        args: typing.List[ManifestBuilderValue],
    ) -> ManifestBuilder: ...
    def call_royalty_method(
        self,
        address: ManifestBuilderAddress,
        method_name: str,
        args: typing.List[ManifestBuilderValue],
    ) -> ManifestBuilder: ...
    def clone_proof(
        self, proof: ManifestBuilderProof, into_proof: ManifestBuilderProof
    ) -> ManifestBuilder: ...
    def create_fungible_resource_manager(
        self,
        owner_role: OwnerRole,
        track_total_supply: bool,
        divisibility: int,
        initial_supply: typing.Optional[Decimal],
        resource_roles: FungibleResourceRoles,
        metadata: MetadataModuleConfig,
        address_reservation: typing.Optional[ManifestBuilderAddressReservation],
    ) -> ManifestBuilder: ...
    def create_proof_from_auth_zone_of_all(
        self, resource_address: Address, into_proof: ManifestBuilderProof
    ) -> ManifestBuilder: ...
    def create_proof_from_auth_zone_of_amount(
        self,
        resource_address: Address,
        amount: Decimal,
        into_proof: ManifestBuilderProof,
    ) -> ManifestBuilder: ...
    def create_proof_from_auth_zone_of_non_fungibles(
        self,
        resource_address: Address,
        ids: typing.List[NonFungibleLocalId],
        into_proof: ManifestBuilderProof,
    ) -> ManifestBuilder: ...
    def create_proof_from_bucket_of_all(
        self, bucket: ManifestBuilderBucket, into_proof: ManifestBuilderProof
    ) -> ManifestBuilder: ...
    def create_proof_from_bucket_of_amount(
        self,
        amount: Decimal,
        bucket: ManifestBuilderBucket,
        into_proof: ManifestBuilderProof,
    ) -> ManifestBuilder: ...
    def create_proof_from_bucket_of_non_fungibles(
        self,
        ids: typing.List[NonFungibleLocalId],
        bucket: ManifestBuilderBucket,
        into_proof: ManifestBuilderProof,
    ) -> ManifestBuilder: ...
    def drop_all_proofs(self) -> ManifestBuilder: ...
    def drop_auth_zone_proofs(self) -> ManifestBuilder: ...
    def drop_auth_zone_signature_proofs(self) -> ManifestBuilder: ...
    def drop_proof(self, proof: ManifestBuilderProof) -> ManifestBuilder: ...
    def faucet_free_xrd(self) -> ManifestBuilder: ...
    def faucet_lock_fee(self) -> ManifestBuilder: ...
    def identity_create(self) -> ManifestBuilder: ...
    def identity_create_advanced(self, owner_role: OwnerRole) -> ManifestBuilder: ...
    def identity_securify(self, address: Address) -> ManifestBuilder: ...
    def metadata_get(self, address: Address, key: str) -> ManifestBuilder: ...
    def metadata_lock(self, address: Address, key: str) -> ManifestBuilder: ...
    def metadata_remove(self, address: Address, key: str) -> ManifestBuilder: ...
    def metadata_set(
        self, address: Address, key: str, value: MetadataValue
    ) -> ManifestBuilder: ...
    def mint_fungible(
        self, resource_address: Address, amount: Decimal
    ) -> ManifestBuilder: ...
    def multi_resource_pool_contribute(
        self, address: Address, buckets: typing.List[ManifestBuilderBucket]
    ) -> ManifestBuilder: ...
    def multi_resource_pool_get_redemption_value(
        self, address: Address, amount_of_pool_units: Decimal
    ) -> ManifestBuilder: ...
    def multi_resource_pool_get_vault_amount(
        self, address: Address
    ) -> ManifestBuilder: ...
    def multi_resource_pool_instantiate(
        self,
        owner_role: OwnerRole,
        pool_manager_rule: AccessRule,
        resource_addresses: typing.List[Address],
        address_reservation: typing.Optional[ManifestBuilderAddressReservation],
    ) -> ManifestBuilder: ...
    def multi_resource_pool_protected_deposit(
        self, address: Address, bucket: ManifestBuilderBucket
    ) -> ManifestBuilder: ...
    def multi_resource_pool_protected_withdraw(
        self,
        address: Address,
        resource_address: Address,
        amount: Decimal,
        withdraw_strategy: WithdrawStrategy,
    ) -> ManifestBuilder: ...
    def multi_resource_pool_redeem(
        self, address: Address, bucket: ManifestBuilderBucket
    ) -> ManifestBuilder: ...
    def one_resource_pool_contribute(
        self, address: Address, bucket: ManifestBuilderBucket
    ) -> ManifestBuilder: ...
    def one_resource_pool_get_redemption_value(
        self, address: Address, amount_of_pool_units: Decimal
    ) -> ManifestBuilder: ...
    def one_resource_pool_get_vault_amount(
        self, address: Address
    ) -> ManifestBuilder: ...
    def one_resource_pool_instantiate(
        self,
        owner_role: OwnerRole,
        pool_manager_rule: AccessRule,
        resource_address: Address,
        address_reservation: typing.Optional[ManifestBuilderAddressReservation],
    ) -> ManifestBuilder: ...
    def one_resource_pool_protected_deposit(
        self, address: Address, bucket: ManifestBuilderBucket
    ) -> ManifestBuilder: ...
    def one_resource_pool_protected_withdraw(
        self, address: Address, amount: Decimal, withdraw_strategy: WithdrawStrategy
    ) -> ManifestBuilder: ...
    def one_resource_pool_redeem(
        self, address: Address, bucket: ManifestBuilderBucket
    ) -> ManifestBuilder: ...
    def package_claim_royalty(self, address: Address) -> ManifestBuilder: ...
    def package_publish(
        self, code: bytes, definition: bytes, metadata: dict
    ) -> ManifestBuilder: ...
    def package_publish_advanced(
        self,
        owner_role: OwnerRole,
        code: bytes,
        definition: bytes,
        metadata: dict,
        package_address: typing.Optional[ManifestBuilderAddressReservation],
    ) -> ManifestBuilder: ...
    def pop_from_auth_zone(
        self, into_proof: ManifestBuilderProof
    ) -> ManifestBuilder: ...
    def push_to_auth_zone(self, proof: ManifestBuilderProof) -> ManifestBuilder: ...
    def return_to_worktop(self, bucket: ManifestBuilderBucket) -> ManifestBuilder: ...
    def role_assignment_get(
        self, address: Address, module: ModuleId, role_key: str
    ) -> ManifestBuilder: ...
    def role_assignment_lock_owner(self, address: Address) -> ManifestBuilder: ...
    def role_assignment_set(
        self, address: Address, module: ModuleId, role_key: str, rule: AccessRule
    ) -> ManifestBuilder: ...
    def role_assignment_set_owner(
        self, address: Address, rule: AccessRule
    ) -> ManifestBuilder: ...
    def royalty_claim(self, address: Address) -> ManifestBuilder: ...
    def royalty_lock(self, address: Address, method: str) -> ManifestBuilder: ...
    def royalty_set(
        self, address: Address, method: str, amount: RoyaltyAmount
    ) -> ManifestBuilder: ...
    def take_all_from_worktop(
        self, resource_address: Address, into_bucket: ManifestBuilderBucket
    ) -> ManifestBuilder: ...
    def take_from_worktop(
        self,
        resource_address: Address,
        amount: Decimal,
        into_bucket: ManifestBuilderBucket,
    ) -> ManifestBuilder: ...
    def take_non_fungibles_from_worktop(
        self,
        resource_address: Address,
        ids: typing.List[NonFungibleLocalId],
        into_bucket: ManifestBuilderBucket,
    ) -> ManifestBuilder: ...
    def two_resource_pool_contribute(
        self, address: Address, buckets: typing.List[ManifestBuilderBucket]
    ) -> ManifestBuilder: ...
    def two_resource_pool_get_redemption_value(
        self, address: Address, amount_of_pool_units: Decimal
    ) -> ManifestBuilder: ...
    def two_resource_pool_get_vault_amount(
        self, address: Address
    ) -> ManifestBuilder: ...
    def two_resource_pool_instantiate(
        self,
        owner_role: OwnerRole,
        pool_manager_rule: AccessRule,
        resource_addresses: typing.List[Address],
        address_reservation: typing.Optional[ManifestBuilderAddressReservation],
    ) -> ManifestBuilder: ...
    def two_resource_pool_protected_deposit(
        self, address: Address, bucket: ManifestBuilderBucket
    ) -> ManifestBuilder: ...
    def two_resource_pool_protected_withdraw(
        self,
        address: Address,
        resource_address: Address,
        amount: Decimal,
        withdraw_strategy: WithdrawStrategy,
    ) -> ManifestBuilder: ...
    def two_resource_pool_redeem(
        self, address: Address, bucket: ManifestBuilderBucket
    ) -> ManifestBuilder: ...
    def validator_accepts_delegated_stake(
        self, address: Address
    ) -> ManifestBuilder: ...
    def validator_claim_xrd(
        self, address: Address, bucket: ManifestBuilderBucket
    ) -> ManifestBuilder: ...
    def validator_finish_unlock_owner_stake_units(
        self, address: Address
    ) -> ManifestBuilder: ...
    def validator_get_protocol_update_readiness(
        self, address: Address
    ) -> ManifestBuilder: ...
    def validator_get_redemption_value(
        self, address: Address, amount_of_stake_units: Decimal
    ) -> ManifestBuilder: ...
    def validator_lock_owner_stake_units(
        self, address: Address, stake_unit_bucket: ManifestBuilderBucket
    ) -> ManifestBuilder: ...
    def validator_register(self, address: Address) -> ManifestBuilder: ...
    def validator_signal_protocol_update_readiness(
        self, address: Address, vote: str
    ) -> ManifestBuilder: ...
    def validator_stake(
        self, address: Address, stake: ManifestBuilderBucket
    ) -> ManifestBuilder: ...
    def validator_stake_as_owner(
        self, address: Address, stake: ManifestBuilderBucket
    ) -> ManifestBuilder: ...
    def validator_start_unlock_owner_stake_units(
        self, address: Address, requested_stake_unit_amount: Decimal
    ) -> ManifestBuilder: ...
    def validator_total_stake_unit_supply(
        self, address: Address
    ) -> ManifestBuilder: ...
    def validator_total_stake_xrd_amount(self, address: Address) -> ManifestBuilder: ...
    def validator_unregister(self, address: Address) -> ManifestBuilder: ...
    def validator_unstake(
        self, address: Address, stake_unit_bucket: ManifestBuilderBucket
    ) -> ManifestBuilder: ...
    def validator_update_accept_delegated_stake(
        self, address: Address, accept_delegated_stake: bool
    ) -> ManifestBuilder: ...
    def validator_update_fee(
        self, address: Address, new_fee_factor: Decimal
    ) -> ManifestBuilder: ...
    def validator_update_key(
        self, address: Address, key: PublicKey
    ) -> ManifestBuilder: ...

class _UniffiConverterTypeManifestBuilder:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class MessageValidationConfig:
    def __init__(
        self,
        max_plaintext_message_length: int,
        max_encrypted_message_length: int,
        max_mime_type_length: int,
        max_decryptors: int,
    ) -> Any: ...
    def __del__(self) -> None: ...
    @classmethod
    def default(cls): ...
    def max_decryptors(self) -> int: ...
    def max_encrypted_message_length(self) -> int: ...
    def max_mime_type_length(self) -> int: ...
    def max_plaintext_message_length(self) -> int: ...

class _UniffiConverterTypeMessageValidationConfig:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class NonFungibleGlobalId:
    def __init__(self, non_fungible_global_id: str) -> Any: ...
    def __del__(self) -> None: ...
    @classmethod
    def from_parts(
        cls: Any, resource_address: Address, non_fungible_local_id: NonFungibleLocalId
    ) -> Any: ...
    @classmethod
    def virtual_signature_badge(
        cls: Any, public_key: PublicKey, network_id: int
    ) -> Any: ...
    def as_str(self) -> str: ...
    def local_id(self) -> NonFungibleLocalId: ...
    def resource_address(self) -> Address: ...

class _UniffiConverterTypeNonFungibleGlobalId:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class NotarizedTransaction:
    def __init__(
        self, signed_intent: SignedIntent, notary_signature: Signature
    ) -> Any: ...
    def __del__(self) -> None: ...
    @classmethod
    def decompile(cls: Any, compiled_notarized_transaction: bytes) -> Any: ...
    def compile(self) -> bytes: ...
    def hash(self) -> TransactionHash: ...
    def intent_hash(self) -> TransactionHash: ...
    def notarized_transaction_hash(self) -> TransactionHash: ...
    def notary_signature(self) -> Signature: ...
    def signed_intent(self) -> SignedIntent: ...
    def signed_intent_hash(self) -> TransactionHash: ...
    def statically_validate(self, validation_config: ValidationConfig) -> Any: ...

class _UniffiConverterTypeNotarizedTransaction:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class OlympiaAddress:
    def __init__(self, address: str) -> Any: ...
    def __del__(self) -> None: ...
    def as_str(self) -> str: ...
    def public_key(self) -> PublicKey: ...

class _UniffiConverterTypeOlympiaAddress:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class PreciseDecimal:
    def __init__(self, value: str) -> Any: ...
    def __del__(self) -> None: ...
    @classmethod
    def max(cls): ...
    @classmethod
    def min(cls): ...
    @classmethod
    def one(cls): ...
    @classmethod
    def zero(cls): ...
    def abs(self) -> PreciseDecimal: ...
    def add(self, other: PreciseDecimal) -> PreciseDecimal: ...
    def as_str(self) -> str: ...
    def cbrt(self) -> PreciseDecimal: ...
    def ceiling(self) -> PreciseDecimal: ...
    def div(self, other: PreciseDecimal) -> PreciseDecimal: ...
    def equal(self, other: PreciseDecimal) -> bool: ...
    def floor(self) -> PreciseDecimal: ...
    def greater_than(self, other: PreciseDecimal) -> bool: ...
    def greater_than_or_equal(self, other: PreciseDecimal) -> bool: ...
    def is_negative(self) -> bool: ...
    def is_positive(self) -> bool: ...
    def is_zero(self) -> bool: ...
    def less_than(self, other: PreciseDecimal) -> bool: ...
    def less_than_or_equal(self, other: PreciseDecimal) -> bool: ...
    def mantissa(self) -> str: ...
    def mul(self, other: PreciseDecimal) -> PreciseDecimal: ...
    def not_equal(self, other: PreciseDecimal) -> bool: ...
    def nth_root(self, n: int) -> typing.Optional[PreciseDecimal]: ...
    def powi(self, exp: int) -> PreciseDecimal: ...
    def round(
        self, decimal_places: int, rounding_mode: RoundingMode
    ) -> PreciseDecimal: ...
    def sqrt(self) -> typing.Optional[PreciseDecimal]: ...
    def sub(self, other: PreciseDecimal) -> PreciseDecimal: ...

class _UniffiConverterTypePreciseDecimal:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class PrivateKey:
    def __init__(self, bytes: bytes, curve: Curve) -> Any: ...
    def __del__(self) -> None: ...
    @classmethod
    def new_ed25519(cls: Any, bytes: bytes) -> Any: ...
    @classmethod
    def new_secp256k1(cls: Any, bytes: bytes) -> Any: ...
    def curve(self) -> Curve: ...
    def public_key(self) -> PublicKey: ...
    def public_key_bytes(self) -> bytes: ...
    def raw(self) -> bytes: ...
    def raw_hex(self) -> str: ...
    def sign(self, hash: Hash) -> bytes: ...
    def sign_to_signature(self, hash: Hash) -> Signature: ...
    def sign_to_signature_with_public_key(
        self, hash: Hash
    ) -> SignatureWithPublicKey: ...

class _UniffiConverterTypePrivateKey:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class SignedIntent:
    def __init__(
        self, intent: Intent, intent_signatures: typing.List[SignatureWithPublicKey]
    ) -> Any: ...
    def __del__(self) -> None: ...
    @classmethod
    def decompile(cls: Any, compiled_signed_intent: bytes) -> Any: ...
    def compile(self) -> bytes: ...
    def hash(self) -> TransactionHash: ...
    def intent(self) -> Intent: ...
    def intent_hash(self) -> TransactionHash: ...
    def intent_signatures(self) -> typing.List[SignatureWithPublicKey]: ...
    def signed_intent_hash(self) -> TransactionHash: ...
    def statically_validate(self, validation_config: ValidationConfig) -> Any: ...

class _UniffiConverterTypeSignedIntent:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class TransactionBuilder:
    def __init__(self) -> None: ...
    def __del__(self) -> None: ...
    def header(self, header: TransactionHeader) -> TransactionBuilderHeaderStep: ...

class _UniffiConverterTypeTransactionBuilder:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class TransactionBuilderHeaderStep:
    def __del__(self) -> None: ...
    def manifest(
        self, manifest: TransactionManifest
    ) -> TransactionBuilderMessageStep: ...

class _UniffiConverterTypeTransactionBuilderHeaderStep:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class TransactionBuilderIntentSignaturesStep:
    def __init__(self, message_step: TransactionBuilderMessageStep) -> Any: ...
    def __del__(self) -> None: ...
    def notarize_with_private_key(
        self, private_key: PrivateKey
    ) -> NotarizedTransaction: ...
    def notarize_with_signer(self, signer: Signer) -> NotarizedTransaction: ...
    def sign_with_private_key(
        self, private_key: PrivateKey
    ) -> TransactionBuilderIntentSignaturesStep: ...
    def sign_with_signer(
        self, signer: Signer
    ) -> TransactionBuilderIntentSignaturesStep: ...

class _UniffiConverterTypeTransactionBuilderIntentSignaturesStep:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class TransactionBuilderMessageStep:
    def __del__(self) -> None: ...
    def message(self, message: Message) -> TransactionBuilderIntentSignaturesStep: ...
    def sign_with_private_key(
        self, private_key: PrivateKey
    ) -> TransactionBuilderIntentSignaturesStep: ...
    def sign_with_signer(
        self, signer: Signer
    ) -> TransactionBuilderIntentSignaturesStep: ...

class _UniffiConverterTypeTransactionBuilderMessageStep:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class TransactionHash:
    def __del__(self) -> None: ...
    @classmethod
    def from_str(cls: Any, string: str, network_id: int) -> Any: ...
    def as_hash(self) -> Hash: ...
    def as_str(self) -> str: ...
    def bytes(self) -> bytes: ...
    def network_id(self) -> int: ...

class _UniffiConverterTypeTransactionHash:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class TransactionManifest:
    def __init__(
        self, instructions: Instructions, blobs: typing.List[bytes]
    ) -> Any: ...
    def __del__(self) -> None: ...
    @classmethod
    def decompile(cls: Any, compiled: bytes, network_id: int) -> Any: ...
    def blobs(self) -> typing.List[bytes]: ...
    def compile(self) -> bytes: ...
    def execution_summary(
        self, network_id: int, encoded_receipt: bytes
    ) -> ExecutionSummary: ...
    def extract_addresses(self) -> dict: ...
    def instructions(self) -> Instructions: ...
    def modify(
        self, modifications: TransactionManifestModifications
    ) -> TransactionManifest: ...
    def statically_validate(self) -> None: ...
    def summary(self, network_id: int) -> ManifestSummary: ...

class _UniffiConverterTypeTransactionManifest:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class ValidationConfig:
    def __init__(
        self,
        network_id: int,
        max_notarized_payload_size: int,
        min_tip_percentage: int,
        max_tip_percentage: int,
        max_epoch_range: int,
        message_validation: MessageValidationConfig,
    ) -> Any: ...
    def __del__(self) -> None: ...
    @classmethod
    def default(cls: Any, network_id: int) -> Any: ...
    def max_epoch_range(self) -> int: ...
    def max_notarized_payload_size(self) -> int: ...
    def max_tip_percentage(self) -> int: ...
    def message_validation(self) -> MessageValidationConfig: ...
    def min_tip_percentage(self) -> int: ...
    def network_id(self) -> int: ...

class _UniffiConverterTypeValidationConfig:
    @classmethod
    def read(cls, buf: Any): ...
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @staticmethod
    def lift(value: Any): ...
    @staticmethod
    def lower(value: Any): ...

class AccountAddAuthorizedDepositorEvent:
    authorized_depositor_badge: ResourceOrNonFungible
    def __init__(self, authorized_depositor_badge: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeAccountAddAuthorizedDepositorEvent(
    _UniffiConverterRustBuffer
):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class AccountRemoveAuthorizedDepositorEvent:
    authorized_depositor_badge: ResourceOrNonFungible
    def __init__(self, authorized_depositor_badge: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeAccountRemoveAuthorizedDepositorEvent(
    _UniffiConverterRustBuffer
):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class AccountRemoveResourcePreferenceEvent:
    resource_address: Address
    def __init__(self, resource_address: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeAccountRemoveResourcePreferenceEvent(
    _UniffiConverterRustBuffer
):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class AccountSetDefaultDepositRuleEvent:
    default_deposit_rule: AccountDefaultDepositRule
    def __init__(self, default_deposit_rule: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeAccountSetDefaultDepositRuleEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class AccountSetResourcePreferenceEvent:
    resource_address: Address
    preference: ResourcePreference
    def __init__(self, resource_address: Any, preference: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeAccountSetResourcePreferenceEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class BadgeWithdrawEvent:
    proposer: Proposer
    def __init__(self, proposer: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeBadgeWithdrawEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class BuildInformation:
    version: str
    scrypto_dependency: DependencyInformation
    def __init__(self, version: Any, scrypto_dependency: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeBuildInformation(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class BurnFungibleResourceEvent:
    amount: Decimal
    def __init__(self, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeBurnFungibleResourceEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class BurnNonFungibleResourceEvent:
    ids: typing.List[NonFungibleLocalId]
    def __init__(self, ids: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeBurnNonFungibleResourceEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class CancelBadgeWithdrawAttemptEvent:
    proposer: Proposer
    def __init__(self, proposer: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeCancelBadgeWithdrawAttemptEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class CancelRecoveryProposalEvent:
    proposer: Proposer
    def __init__(self, proposer: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeCancelRecoveryProposalEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ClaimXrdEvent:
    claimed_xrd: Decimal
    def __init__(self, claimed_xrd: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeClaimXrdEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ComponentAddresses:
    consensus_manager: Address
    genesis_helper: Address
    faucet: Address
    def __init__(
        self, consensus_manager: Any, genesis_helper: Any, faucet: Any
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeComponentAddresses(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class Ed25519PublicKey:
    value: bytes
    def __init__(self, value: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeEd25519PublicKey(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class EncryptedMessage:
    encrypted: bytes
    decryptors_by_curve: dict
    def __init__(self, encrypted: Any, decryptors_by_curve: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeEncryptedMessage(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class EpochChangeEvent:
    epoch: int
    validator_set: dict
    def __init__(self, epoch: Any, validator_set: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeEpochChangeEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class EventTypeIdentifier:
    emitter: Emitter
    event_name: str
    def __init__(self, emitter: Any, event_name: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeEventTypeIdentifier(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ExecutionSummary:
    account_withdraws: dict
    account_deposits: dict
    presented_proofs: typing.List[Address]
    new_entities: NewEntities
    encountered_entities: typing.List[Address]
    accounts_requiring_auth: typing.List[Address]
    identities_requiring_auth: typing.List[Address]
    reserved_instructions: typing.List[ReservedInstruction]
    fee_locks: FeeLocks
    fee_summary: FeeSummary
    detailed_classification: typing.List[DetailedManifestClass]
    newly_created_non_fungibles: typing.List[NonFungibleGlobalId]
    def __init__(
        self,
        account_withdraws: Any,
        account_deposits: Any,
        presented_proofs: Any,
        new_entities: Any,
        encountered_entities: Any,
        accounts_requiring_auth: Any,
        identities_requiring_auth: Any,
        reserved_instructions: Any,
        fee_locks: Any,
        fee_summary: Any,
        detailed_classification: Any,
        newly_created_non_fungibles: Any,
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeExecutionSummary(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class FeeLocks:
    lock: Decimal
    contingent_lock: Decimal
    def __init__(self, lock: Any, contingent_lock: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeFeeLocks(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class FeeSummary:
    execution_cost: Decimal
    finalization_cost: Decimal
    storage_expansion_cost: Decimal
    royalty_cost: Decimal
    def __init__(
        self,
        execution_cost: Any,
        finalization_cost: Any,
        storage_expansion_cost: Any,
        royalty_cost: Any,
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeFeeSummary(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class FungibleResourceRoles:
    mint_roles: typing.Optional[ResourceManagerRole]
    burn_roles: typing.Optional[ResourceManagerRole]
    freeze_roles: typing.Optional[ResourceManagerRole]
    recall_roles: typing.Optional[ResourceManagerRole]
    withdraw_roles: typing.Optional[ResourceManagerRole]
    deposit_roles: typing.Optional[ResourceManagerRole]
    def __init__(
        self,
        mint_roles: Any,
        burn_roles: Any,
        freeze_roles: Any,
        recall_roles: Any,
        withdraw_roles: Any,
        deposit_roles: Any,
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeFungibleResourceRoles(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class FungibleVaultDepositEvent:
    amount: Decimal
    def __init__(self, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeFungibleVaultDepositEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class FungibleVaultLockFeeEvent:
    amount: Decimal
    def __init__(self, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeFungibleVaultLockFeeEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class FungibleVaultPayFeeEvent:
    amount: Decimal
    def __init__(self, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeFungibleVaultPayFeeEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class FungibleVaultRecallEvent:
    amount: Decimal
    def __init__(self, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeFungibleVaultRecallEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class FungibleVaultWithdrawEvent:
    amount: Decimal
    def __init__(self, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeFungibleVaultWithdrawEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class IndexedAssertion:
    index: int
    assertion: Assertion
    def __init__(self, index: Any, assertion: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeIndexedAssertion(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class InitiateBadgeWithdrawAttemptEvent:
    proposer: Proposer
    def __init__(self, proposer: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeInitiateBadgeWithdrawAttemptEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class InitiateRecoveryEvent:
    proposer: Proposer
    proposal: RecoveryProposal
    def __init__(self, proposer: Any, proposal: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeInitiateRecoveryEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class KnownAddresses:
    resource_addresses: ResourceAddresses
    package_addresses: PackageAddresses
    component_addresses: ComponentAddresses
    def __init__(
        self, resource_addresses: Any, package_addresses: Any, component_addresses: Any
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeKnownAddresses(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class LockFeeModification:
    account_address: Address
    amount: Decimal
    def __init__(self, account_address: Any, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeLockFeeModification(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class LockOwnerRoleEvent:
    placeholder_field: bool
    def __init__(self, placeholder_field: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeLockOwnerRoleEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class LockPrimaryRoleEvent:
    placeholder_field: bool
    def __init__(self, placeholder_field: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeLockPrimaryRoleEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class LockRoleEvent:
    role_key: str
    def __init__(self, role_key: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeLockRoleEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ManifestAddressReservation:
    value: int
    def __init__(self, value: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeManifestAddressReservation(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ManifestBlobRef:
    value: Hash
    def __init__(self, value: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeManifestBlobRef(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ManifestBucket:
    value: int
    def __init__(self, value: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeManifestBucket(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ManifestBuilderAddressReservation:
    name: str
    def __init__(self, name: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeManifestBuilderAddressReservation(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ManifestBuilderBucket:
    name: str
    def __init__(self, name: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeManifestBuilderBucket(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ManifestBuilderMapEntry:
    key: ManifestBuilderValue
    value: ManifestBuilderValue
    def __init__(self, key: Any, value: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeManifestBuilderMapEntry(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ManifestBuilderNamedAddress:
    name: str
    def __init__(self, name: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeManifestBuilderNamedAddress(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ManifestBuilderProof:
    name: str
    def __init__(self, name: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeManifestBuilderProof(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ManifestProof:
    value: int
    def __init__(self, value: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeManifestProof(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ManifestSummary:
    presented_proofs: typing.List[Address]
    accounts_withdrawn_from: typing.List[Address]
    accounts_deposited_into: typing.List[Address]
    encountered_entities: typing.List[Address]
    accounts_requiring_auth: typing.List[Address]
    identities_requiring_auth: typing.List[Address]
    reserved_instructions: typing.List[ReservedInstruction]
    classification: typing.List[ManifestClass]
    def __init__(
        self,
        presented_proofs: Any,
        accounts_withdrawn_from: Any,
        accounts_deposited_into: Any,
        encountered_entities: Any,
        accounts_requiring_auth: Any,
        identities_requiring_auth: Any,
        reserved_instructions: Any,
        classification: Any,
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeManifestSummary(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class MapEntry:
    key: ManifestValue
    value: ManifestValue
    def __init__(self, key: Any, value: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeMapEntry(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class MetadataInitEntry:
    value: typing.Optional[MetadataValue]
    lock: bool
    def __init__(self, value: Any, lock: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeMetadataInitEntry(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class MetadataModuleConfig:
    init: dict
    roles: dict
    def __init__(self, init: Any, roles: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeMetadataModuleConfig(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class MintFungibleResourceEvent:
    amount: Decimal
    def __init__(self, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeMintFungibleResourceEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class MintNonFungibleResourceEvent:
    ids: typing.List[NonFungibleLocalId]
    def __init__(self, ids: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeMintNonFungibleResourceEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class MultiResourcePoolContributionEvent:
    contributed_resources: dict
    pool_units_minted: Decimal
    def __init__(self, contributed_resources: Any, pool_units_minted: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeMultiResourcePoolContributionEvent(
    _UniffiConverterRustBuffer
):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class MultiResourcePoolDepositEvent:
    resource_address: Address
    amount: Decimal
    def __init__(self, resource_address: Any, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeMultiResourcePoolDepositEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class MultiResourcePoolRedemptionEvent:
    pool_unit_tokens_redeemed: Decimal
    redeemed_resources: dict
    def __init__(
        self, pool_unit_tokens_redeemed: Any, redeemed_resources: Any
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeMultiResourcePoolRedemptionEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class MultiResourcePoolWithdrawEvent:
    resource_address: Address
    amount: Decimal
    def __init__(self, resource_address: Any, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeMultiResourcePoolWithdrawEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class NewEntities:
    component_addresses: typing.List[Address]
    resource_addresses: typing.List[Address]
    package_addresses: typing.List[Address]
    metadata: dict
    def __init__(
        self,
        component_addresses: Any,
        resource_addresses: Any,
        package_addresses: Any,
        metadata: Any,
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeNewEntities(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class NonFungibleVaultDepositEvent:
    ids: typing.List[NonFungibleLocalId]
    def __init__(self, ids: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeNonFungibleVaultDepositEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class NonFungibleVaultRecallEvent:
    ids: typing.List[NonFungibleLocalId]
    def __init__(self, ids: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeNonFungibleVaultRecallEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class NonFungibleVaultWithdrawEvent:
    ids: typing.List[NonFungibleLocalId]
    def __init__(self, ids: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeNonFungibleVaultWithdrawEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class OneResourcePoolContributionEvent:
    amount_of_resources_contributed: Decimal
    pool_units_minted: Decimal
    def __init__(
        self, amount_of_resources_contributed: Any, pool_units_minted: Any
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeOneResourcePoolContributionEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class OneResourcePoolDepositEvent:
    amount: Decimal
    def __init__(self, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeOneResourcePoolDepositEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class OneResourcePoolRedemptionEvent:
    pool_unit_tokens_redeemed: Decimal
    redeemed_amount: Decimal
    def __init__(
        self, pool_unit_tokens_redeemed: Any, redeemed_amount: Any
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeOneResourcePoolRedemptionEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class OneResourcePoolWithdrawEvent:
    amount: Decimal
    def __init__(self, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeOneResourcePoolWithdrawEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class PackageAddresses:
    package_package: Address
    resource_package: Address
    account_package: Address
    identity_package: Address
    consensus_manager_package: Address
    access_controller_package: Address
    pool_package: Address
    transaction_processor_package: Address
    metadata_module_package: Address
    royalty_module_package: Address
    role_assignment_module_package: Address
    genesis_helper_package: Address
    faucet_package: Address
    def __init__(
        self,
        package_package: Any,
        resource_package: Any,
        account_package: Any,
        identity_package: Any,
        consensus_manager_package: Any,
        access_controller_package: Any,
        pool_package: Any,
        transaction_processor_package: Any,
        metadata_module_package: Any,
        royalty_module_package: Any,
        role_assignment_module_package: Any,
        genesis_helper_package: Any,
        faucet_package: Any,
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypePackageAddresses(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class PlainTextMessage:
    mime_type: str
    message: MessageContent
    def __init__(self, mime_type: Any, message: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypePlainTextMessage(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class PredictedDecimal:
    value: Decimal
    instruction_index: int
    def __init__(self, value: Any, instruction_index: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypePredictedDecimal(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class PredictedNonFungibleIds:
    value: typing.List[NonFungibleLocalId]
    instruction_index: int
    def __init__(self, value: Any, instruction_index: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypePredictedNonFungibleIds(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ProtocolUpdateReadinessSignalEvent:
    protocol_version_name: str
    def __init__(self, protocol_version_name: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeProtocolUpdateReadinessSignalEvent(
    _UniffiConverterRustBuffer
):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class RecoveryProposal:
    rule_set: RuleSet
    timed_recovery_delay_in_minutes: typing.Optional[int]
    def __init__(self, rule_set: Any, timed_recovery_delay_in_minutes: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeRecoveryProposal(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class RegisterValidatorEvent:
    placeholder_field: bool
    def __init__(self, placeholder_field: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeRegisterValidatorEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class RemoveMetadataEvent:
    key: str
    def __init__(self, key: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeRemoveMetadataEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ResourceAddresses:
    xrd: Address
    secp256k1_signature_virtual_badge: Address
    ed25519_signature_virtual_badge: Address
    package_of_direct_caller_virtual_badge: Address
    global_caller_virtual_badge: Address
    system_transaction_badge: Address
    package_owner_badge: Address
    validator_owner_badge: Address
    account_owner_badge: Address
    identity_owner_badge: Address
    def __init__(
        self,
        xrd: Any,
        secp256k1_signature_virtual_badge: Any,
        ed25519_signature_virtual_badge: Any,
        package_of_direct_caller_virtual_badge: Any,
        global_caller_virtual_badge: Any,
        system_transaction_badge: Any,
        package_owner_badge: Any,
        validator_owner_badge: Any,
        account_owner_badge: Any,
        identity_owner_badge: Any,
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeResourceAddresses(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ResourceManagerRole:
    role: typing.Optional[AccessRule]
    role_updater: typing.Optional[AccessRule]
    def __init__(self, role: Any, role_updater: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeResourceManagerRole(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class RoundChangeEvent:
    round: int
    def __init__(self, round: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeRoundChangeEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class RuleSet:
    primary_role: AccessRule
    recovery_role: AccessRule
    confirmation_role: AccessRule
    def __init__(
        self, primary_role: Any, recovery_role: Any, confirmation_role: Any
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeRuleSet(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class RuleSetUpdateEvent:
    proposer: Proposer
    proposal: RecoveryProposal
    def __init__(self, proposer: Any, proposal: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeRuleSetUpdateEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class Schema:
    local_type_id: LocalTypeId
    schema: bytes
    def __init__(self, local_type_id: Any, schema: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeSchema(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class Secp256k1PublicKey:
    value: bytes
    def __init__(self, value: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeSecp256k1PublicKey(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class SecurityStructureRole:
    super_admin_factors: typing.List[PublicKey]
    threshold_factors: typing.List[PublicKey]
    threshold: int
    def __init__(
        self, super_admin_factors: Any, threshold_factors: Any, threshold: Any
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeSecurityStructureRole(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class SetAndLockRoleEvent:
    role_key: str
    rule: AccessRule
    def __init__(self, role_key: Any, rule: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeSetAndLockRoleEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class SetMetadataEvent:
    key: str
    value: MetadataValue
    def __init__(self, key: Any, value: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeSetMetadataEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class SetOwnerRoleEvent:
    rule: AccessRule
    def __init__(self, rule: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeSetOwnerRoleEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class SetRoleEvent:
    role_key: str
    rule: AccessRule
    def __init__(self, role_key: Any, rule: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeSetRoleEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class StakeEvent:
    xrd_staked: Decimal
    def __init__(self, xrd_staked: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeStakeEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class StopTimedRecoveryEvent:
    placeholder_field: bool
    def __init__(self, placeholder_field: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeStopTimedRecoveryEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class TrackedPoolContribution:
    pool_address: Address
    contributed_resources: dict
    pool_units_resource_address: Address
    pool_units_amount: Decimal
    def __init__(
        self,
        pool_address: Any,
        contributed_resources: Any,
        pool_units_resource_address: Any,
        pool_units_amount: Any,
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeTrackedPoolContribution(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class TrackedPoolRedemption:
    pool_address: Address
    pool_units_resource_address: Address
    pool_units_amount: Decimal
    redeemed_resources: dict
    def __init__(
        self,
        pool_address: Any,
        pool_units_resource_address: Any,
        pool_units_amount: Any,
        redeemed_resources: Any,
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeTrackedPoolRedemption(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class TrackedValidatorClaim:
    validator_address: Address
    claim_nft_address: Address
    claim_nft_ids: typing.List[NonFungibleLocalId]
    xrd_amount: Decimal
    def __init__(
        self,
        validator_address: Any,
        claim_nft_address: Any,
        claim_nft_ids: Any,
        xrd_amount: Any,
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeTrackedValidatorClaim(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class TrackedValidatorStake:
    validator_address: Address
    xrd_amount: Decimal
    liquid_stake_unit_address: Address
    liquid_stake_unit_amount: Decimal
    def __init__(
        self,
        validator_address: Any,
        xrd_amount: Any,
        liquid_stake_unit_address: Any,
        liquid_stake_unit_amount: Any,
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeTrackedValidatorStake(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class TrackedValidatorUnstake:
    validator_address: Address
    liquid_stake_unit_address: Address
    liquid_stake_unit_amount: Decimal
    claim_nft_address: Address
    claim_nft_ids: typing.List[NonFungibleLocalId]
    def __init__(
        self,
        validator_address: Any,
        liquid_stake_unit_address: Any,
        liquid_stake_unit_amount: Any,
        claim_nft_address: Any,
        claim_nft_ids: Any,
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeTrackedValidatorUnstake(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class TransactionHeader:
    network_id: int
    start_epoch_inclusive: int
    end_epoch_exclusive: int
    nonce: int
    notary_public_key: PublicKey
    notary_is_signatory: bool
    tip_percentage: int
    def __init__(
        self,
        network_id: Any,
        start_epoch_inclusive: Any,
        end_epoch_exclusive: Any,
        nonce: Any,
        notary_public_key: Any,
        notary_is_signatory: Any,
        tip_percentage: Any,
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeTransactionHeader(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class TransactionManifestModifications:
    add_access_controller_proofs: typing.List[Address]
    add_lock_fee: typing.Optional[LockFeeModification]
    add_assertions: typing.List[IndexedAssertion]
    def __init__(
        self, add_access_controller_proofs: Any, add_lock_fee: Any, add_assertions: Any
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeTransactionManifestModifications(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class TwoResourcePoolContributionEvent:
    contributed_resources: dict
    pool_units_minted: Decimal
    def __init__(self, contributed_resources: Any, pool_units_minted: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeTwoResourcePoolContributionEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class TwoResourcePoolDepositEvent:
    resource_address: Address
    amount: Decimal
    def __init__(self, resource_address: Any, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeTwoResourcePoolDepositEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class TwoResourcePoolRedemptionEvent:
    pool_unit_tokens_redeemed: Decimal
    redeemed_resources: dict
    def __init__(
        self, pool_unit_tokens_redeemed: Any, redeemed_resources: Any
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeTwoResourcePoolRedemptionEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class TwoResourcePoolWithdrawEvent:
    resource_address: Address
    amount: Decimal
    def __init__(self, resource_address: Any, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeTwoResourcePoolWithdrawEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class UnlockPrimaryRoleEvent:
    placeholder_field: bool
    def __init__(self, placeholder_field: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeUnlockPrimaryRoleEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class UnregisterValidatorEvent:
    placeholder_field: bool
    def __init__(self, placeholder_field: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeUnregisterValidatorEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class UnstakeData:
    name: str
    claim_epoch: int
    claim_amount: Decimal
    def __init__(self, name: Any, claim_epoch: Any, claim_amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeUnstakeData(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class UnstakeDataEntry:
    non_fungible_global_id: NonFungibleGlobalId
    data: UnstakeData
    def __init__(self, non_fungible_global_id: Any, data: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeUnstakeDataEntry(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class UnstakeEvent:
    stake_units: Decimal
    def __init__(self, stake_units: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeUnstakeEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class UpdateAcceptingStakeDelegationStateEvent:
    accepts_delegation: bool
    def __init__(self, accepts_delegation: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeUpdateAcceptingStakeDelegationStateEvent(
    _UniffiConverterRustBuffer
):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ValidatorEmissionAppliedEvent:
    epoch: int
    starting_stake_pool_xrd: Decimal
    stake_pool_added_xrd: Decimal
    total_stake_unit_supply: Decimal
    validator_fee_xrd: Decimal
    proposals_made: int
    proposals_missed: int
    def __init__(
        self,
        epoch: Any,
        starting_stake_pool_xrd: Any,
        stake_pool_added_xrd: Any,
        total_stake_unit_supply: Any,
        validator_fee_xrd: Any,
        proposals_made: Any,
        proposals_missed: Any,
    ) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeValidatorEmissionAppliedEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ValidatorInfo:
    key: Secp256k1PublicKey
    stake: Decimal
    def __init__(self, key: Any, stake: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeValidatorInfo(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class ValidatorRewardAppliedEvent:
    epoch: int
    amount: Decimal
    def __init__(self, epoch: Any, amount: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeValidatorRewardAppliedEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class VaultCreationEvent:
    vault_id: Address
    def __init__(self, vault_id: Any) -> None: ...
    def __eq__(self, other: Any) -> Any: ...

class _UniffiConverterTypeVaultCreationEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class AccountDefaultDepositRule(enum.Enum):
    ACCEPT: int = ...
    REJECT: int = ...
    ALLOW_EXISTING: int = ...

class _UniffiConverterTypeAccountDefaultDepositRule(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class AccountDepositEvent:
    def __init__(self) -> None: ...

    class FUNGIBLE:
        resource_address: Address
        amount: Decimal
        def __init__(self, resource_address: Any, amount: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class NON_FUNGIBLE:
        resource_address: Address
        ids: typing.List[NonFungibleLocalId]
        def __init__(self, resource_address: Any, ids: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_fungible(self) -> bool: ...
    def is_non_fungible(self) -> bool: ...

class _UniffiConverterTypeAccountDepositEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class AccountRejectedDepositEvent:
    def __init__(self) -> None: ...

    class FUNGIBLE:
        resource_address: Address
        amount: Decimal
        def __init__(self, resource_address: Any, amount: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class NON_FUNGIBLE:
        resource_address: Address
        ids: typing.List[NonFungibleLocalId]
        def __init__(self, resource_address: Any, ids: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_fungible(self) -> bool: ...
    def is_non_fungible(self) -> bool: ...

class _UniffiConverterTypeAccountRejectedDepositEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class AccountWithdrawEvent:
    def __init__(self) -> None: ...

    class FUNGIBLE:
        resource_address: Address
        amount: Decimal
        def __init__(self, resource_address: Any, amount: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class NON_FUNGIBLE:
        resource_address: Address
        ids: typing.List[NonFungibleLocalId]
        def __init__(self, resource_address: Any, ids: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_fungible(self) -> bool: ...
    def is_non_fungible(self) -> bool: ...

class _UniffiConverterTypeAccountWithdrawEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class Assertion:
    def __init__(self) -> None: ...

    class AMOUNT:
        resource_address: Address
        amount: Decimal
        def __init__(self, resource_address: Any, amount: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class IDS:
        resource_address: Address
        ids: typing.List[NonFungibleLocalId]
        def __init__(self, resource_address: Any, ids: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_amount(self) -> bool: ...
    def is_ids(self) -> bool: ...

class _UniffiConverterTypeAssertion(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class Curve(enum.Enum):
    SECP256K1: int = ...
    ED25519: int = ...

class _UniffiConverterTypeCurve(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class CurveType(enum.Enum):
    ED25519: int = ...
    SECP256K1: int = ...

class _UniffiConverterTypeCurveType(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class DecryptorsByCurve:
    def __init__(self) -> None: ...

    class ED25519:
        dh_ephemeral_public_key: Ed25519PublicKey
        decryptors: dict
        def __init__(self, dh_ephemeral_public_key: Any, decryptors: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class SECP256K1:
        dh_ephemeral_public_key: Secp256k1PublicKey
        decryptors: dict
        def __init__(self, dh_ephemeral_public_key: Any, decryptors: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_ed25519(self) -> bool: ...
    def is_secp256k1(self) -> bool: ...

class _UniffiConverterTypeDecryptorsByCurve(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class DependencyInformation:
    def __init__(self) -> None: ...

    class VERSION:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class TAG:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BRANCH:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class REV:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_version(self) -> bool: ...
    def is_tag(self) -> bool: ...
    def is_branch(self) -> bool: ...
    def is_rev(self) -> bool: ...

class _UniffiConverterTypeDependencyInformation(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class DepositResourceEvent:
    def __init__(self) -> None: ...

    class AMOUNT:
        value: Decimal
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class IDS:
        value: typing.List[NonFungibleLocalId]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_amount(self) -> bool: ...
    def is_ids(self) -> bool: ...

class _UniffiConverterTypeDepositResourceEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class DetailedManifestClass:
    def __init__(self) -> None: ...

    class GENERAL:
        def __init__(self) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class TRANSFER:
        is_one_to_one: bool
        def __init__(self, is_one_to_one: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class POOL_CONTRIBUTION:
        pool_addresses: typing.List[Address]
        pool_contributions: typing.List[TrackedPoolContribution]
        def __init__(self, pool_addresses: Any, pool_contributions: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class POOL_REDEMPTION:
        pool_addresses: typing.List[Address]
        pool_redemptions: typing.List[TrackedPoolRedemption]
        def __init__(self, pool_addresses: Any, pool_redemptions: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class VALIDATOR_STAKE:
        validator_addresses: typing.List[Address]
        validator_stakes: typing.List[TrackedValidatorStake]
        def __init__(self, validator_addresses: Any, validator_stakes: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class VALIDATOR_UNSTAKE:
        validator_addresses: typing.List[Address]
        validator_unstakes: typing.List[TrackedValidatorUnstake]
        claims_non_fungible_data: typing.List[UnstakeDataEntry]
        def __init__(
            self,
            validator_addresses: Any,
            validator_unstakes: Any,
            claims_non_fungible_data: Any,
        ) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class VALIDATOR_CLAIM:
        validator_addresses: typing.List[Address]
        validator_claims: typing.List[TrackedValidatorClaim]
        def __init__(self, validator_addresses: Any, validator_claims: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ACCOUNT_DEPOSIT_SETTINGS_UPDATE:
        resource_preferences_updates: dict
        deposit_mode_updates: dict
        authorized_depositors_added: dict
        authorized_depositors_removed: dict
        def __init__(
            self,
            resource_preferences_updates: Any,
            deposit_mode_updates: Any,
            authorized_depositors_added: Any,
            authorized_depositors_removed: Any,
        ) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_general(self) -> bool: ...
    def is_transfer(self) -> bool: ...
    def is_pool_contribution(self) -> bool: ...
    def is_pool_redemption(self) -> bool: ...
    def is_validator_stake(self) -> bool: ...
    def is_validator_unstake(self) -> bool: ...
    def is_validator_claim(self) -> bool: ...
    def is_account_deposit_settings_update(self) -> bool: ...

class _UniffiConverterTypeDetailedManifestClass(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class Emitter:
    def __init__(self) -> None: ...

    class FUNCTION:
        address: Address
        blueprint_name: str
        def __init__(self, address: Any, blueprint_name: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class METHOD:
        address: Address
        object_module_id: ModuleId
        def __init__(self, address: Any, object_module_id: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_function(self) -> bool: ...
    def is_method(self) -> bool: ...

class _UniffiConverterTypeEmitter(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class EntityType(enum.Enum):
    GLOBAL_PACKAGE: int = ...
    GLOBAL_FUNGIBLE_RESOURCE_MANAGER: int = ...
    GLOBAL_NON_FUNGIBLE_RESOURCE_MANAGER: int = ...
    GLOBAL_CONSENSUS_MANAGER: int = ...
    GLOBAL_VALIDATOR: int = ...
    GLOBAL_ACCESS_CONTROLLER: int = ...
    GLOBAL_ACCOUNT: int = ...
    GLOBAL_IDENTITY: int = ...
    GLOBAL_GENERIC_COMPONENT: int = ...
    GLOBAL_VIRTUAL_SECP256K1_ACCOUNT: int = ...
    GLOBAL_VIRTUAL_ED25519_ACCOUNT: int = ...
    GLOBAL_VIRTUAL_SECP256K1_IDENTITY: int = ...
    GLOBAL_VIRTUAL_ED25519_IDENTITY: int = ...
    GLOBAL_ONE_RESOURCE_POOL: int = ...
    GLOBAL_TWO_RESOURCE_POOL: int = ...
    GLOBAL_MULTI_RESOURCE_POOL: int = ...
    GLOBAL_TRANSACTION_TRACKER: int = ...
    INTERNAL_FUNGIBLE_VAULT: int = ...
    INTERNAL_NON_FUNGIBLE_VAULT: int = ...
    INTERNAL_GENERIC_COMPONENT: int = ...
    INTERNAL_KEY_VALUE_STORE: int = ...

class _UniffiConverterTypeEntityType(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class FungibleResourceIndicator:
    def __init__(self) -> None: ...

    class GUARANTEED:
        amount: Decimal
        def __init__(self, amount: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class PREDICTED:
        predicted_amount: PredictedDecimal
        def __init__(self, predicted_amount: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_guaranteed(self) -> bool: ...
    def is_predicted(self) -> bool: ...

class _UniffiConverterTypeFungibleResourceIndicator(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class Instruction:
    def __init__(self) -> None: ...

    class TAKE_ALL_FROM_WORKTOP:
        resource_address: Address
        def __init__(self, resource_address: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class TAKE_FROM_WORKTOP:
        resource_address: Address
        amount: Decimal
        def __init__(self, resource_address: Any, amount: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class TAKE_NON_FUNGIBLES_FROM_WORKTOP:
        resource_address: Address
        ids: typing.List[NonFungibleLocalId]
        def __init__(self, resource_address: Any, ids: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class RETURN_TO_WORKTOP:
        bucket_id: ManifestBucket
        def __init__(self, bucket_id: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ASSERT_WORKTOP_CONTAINS:
        resource_address: Address
        amount: Decimal
        def __init__(self, resource_address: Any, amount: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ASSERT_WORKTOP_CONTAINS_ANY:
        resource_address: Address
        def __init__(self, resource_address: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ASSERT_WORKTOP_CONTAINS_NON_FUNGIBLES:
        resource_address: Address
        ids: typing.List[NonFungibleLocalId]
        def __init__(self, resource_address: Any, ids: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class POP_FROM_AUTH_ZONE:
        def __init__(self) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class PUSH_TO_AUTH_ZONE:
        proof_id: ManifestProof
        def __init__(self, proof_id: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CREATE_PROOF_FROM_AUTH_ZONE_OF_AMOUNT:
        resource_address: Address
        amount: Decimal
        def __init__(self, resource_address: Any, amount: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CREATE_PROOF_FROM_AUTH_ZONE_OF_NON_FUNGIBLES:
        resource_address: Address
        ids: typing.List[NonFungibleLocalId]
        def __init__(self, resource_address: Any, ids: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CREATE_PROOF_FROM_AUTH_ZONE_OF_ALL:
        resource_address: Address
        def __init__(self, resource_address: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class DROP_ALL_PROOFS:
        def __init__(self) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class DROP_NAMED_PROOFS:
        def __init__(self) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class DROP_AUTH_ZONE_PROOFS:
        def __init__(self) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class DROP_AUTH_ZONE_REGULAR_PROOFS:
        def __init__(self) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class DROP_AUTH_ZONE_SIGNATURE_PROOFS:
        def __init__(self) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CREATE_PROOF_FROM_BUCKET_OF_AMOUNT:
        bucket_id: ManifestBucket
        amount: Decimal
        def __init__(self, bucket_id: Any, amount: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CREATE_PROOF_FROM_BUCKET_OF_NON_FUNGIBLES:
        bucket_id: ManifestBucket
        ids: typing.List[NonFungibleLocalId]
        def __init__(self, bucket_id: Any, ids: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CREATE_PROOF_FROM_BUCKET_OF_ALL:
        bucket_id: ManifestBucket
        def __init__(self, bucket_id: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BURN_RESOURCE:
        bucket_id: ManifestBucket
        def __init__(self, bucket_id: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CLONE_PROOF:
        proof_id: ManifestProof
        def __init__(self, proof_id: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class DROP_PROOF:
        proof_id: ManifestProof
        def __init__(self, proof_id: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CALL_FUNCTION:
        package_address: ManifestAddress
        blueprint_name: str
        function_name: str
        args: ManifestValue
        def __init__(
            self,
            package_address: Any,
            blueprint_name: Any,
            function_name: Any,
            args: Any,
        ) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CALL_METHOD:
        address: ManifestAddress
        method_name: str
        args: ManifestValue
        def __init__(self, address: Any, method_name: Any, args: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CALL_ROYALTY_METHOD:
        address: ManifestAddress
        method_name: str
        args: ManifestValue
        def __init__(self, address: Any, method_name: Any, args: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CALL_METADATA_METHOD:
        address: ManifestAddress
        method_name: str
        args: ManifestValue
        def __init__(self, address: Any, method_name: Any, args: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CALL_ROLE_ASSIGNMENT_METHOD:
        address: ManifestAddress
        method_name: str
        args: ManifestValue
        def __init__(self, address: Any, method_name: Any, args: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CALL_DIRECT_VAULT_METHOD:
        address: Address
        method_name: str
        args: ManifestValue
        def __init__(self, address: Any, method_name: Any, args: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ALLOCATE_GLOBAL_ADDRESS:
        package_address: Address
        blueprint_name: str
        def __init__(self, package_address: Any, blueprint_name: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_take_all_from_worktop(self) -> bool: ...
    def is_take_from_worktop(self) -> bool: ...
    def is_take_non_fungibles_from_worktop(self) -> bool: ...
    def is_return_to_worktop(self) -> bool: ...
    def is_assert_worktop_contains(self) -> bool: ...
    def is_assert_worktop_contains_any(self) -> bool: ...
    def is_assert_worktop_contains_non_fungibles(self) -> bool: ...
    def is_pop_from_auth_zone(self) -> bool: ...
    def is_push_to_auth_zone(self) -> bool: ...
    def is_create_proof_from_auth_zone_of_amount(self) -> bool: ...
    def is_create_proof_from_auth_zone_of_non_fungibles(self) -> bool: ...
    def is_create_proof_from_auth_zone_of_all(self) -> bool: ...
    def is_drop_all_proofs(self) -> bool: ...
    def is_drop_named_proofs(self) -> bool: ...
    def is_drop_auth_zone_proofs(self) -> bool: ...
    def is_drop_auth_zone_regular_proofs(self) -> bool: ...
    def is_drop_auth_zone_signature_proofs(self) -> bool: ...
    def is_create_proof_from_bucket_of_amount(self) -> bool: ...
    def is_create_proof_from_bucket_of_non_fungibles(self) -> bool: ...
    def is_create_proof_from_bucket_of_all(self) -> bool: ...
    def is_burn_resource(self) -> bool: ...
    def is_clone_proof(self) -> bool: ...
    def is_drop_proof(self) -> bool: ...
    def is_call_function(self) -> bool: ...
    def is_call_method(self) -> bool: ...
    def is_call_royalty_method(self) -> bool: ...
    def is_call_metadata_method(self) -> bool: ...
    def is_call_role_assignment_method(self) -> bool: ...
    def is_call_direct_vault_method(self) -> bool: ...
    def is_allocate_global_address(self) -> bool: ...

class _UniffiConverterTypeInstruction(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class LocalTypeId:
    def __init__(self) -> None: ...

    class WELL_KNOWN:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class SCHEMA_LOCAL_INDEX:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_well_known(self) -> bool: ...
    def is_schema_local_index(self) -> bool: ...

class _UniffiConverterTypeLocalTypeId(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ManifestAddress:
    def __init__(self) -> None: ...

    class NAMED:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class STATIC:
        value: Address
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_named(self) -> bool: ...
    def is_static(self) -> bool: ...

class _UniffiConverterTypeManifestAddress(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ManifestBuilderAddress:
    def __init__(self) -> None: ...

    class NAMED:
        value: ManifestBuilderNamedAddress
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class STATIC:
        value: Address
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_named(self) -> bool: ...
    def is_static(self) -> bool: ...

class _UniffiConverterTypeManifestBuilderAddress(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ManifestBuilderValue:
    def __init__(self) -> None: ...

    class BOOL_VALUE:
        value: bool
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class I8_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class I16_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class I32_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class I64_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class I128_VALUE:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U8_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U16_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U32_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U64_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U128_VALUE:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class STRING_VALUE:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ENUM_VALUE:
        discriminator: int
        fields: typing.List[ManifestBuilderValue]
        def __init__(self, discriminator: Any, fields: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ARRAY_VALUE:
        element_value_kind: ManifestBuilderValueKind
        elements: typing.List[ManifestBuilderValue]
        def __init__(self, element_value_kind: Any, elements: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class TUPLE_VALUE:
        fields: typing.List[ManifestBuilderValue]
        def __init__(self, fields: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class MAP_VALUE:
        key_value_kind: ManifestBuilderValueKind
        value_value_kind: ManifestBuilderValueKind
        entries: typing.List[ManifestBuilderMapEntry]
        def __init__(
            self, key_value_kind: Any, value_value_kind: Any, entries: Any
        ) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ADDRESS_VALUE:
        value: ManifestBuilderAddress
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BUCKET_VALUE:
        value: ManifestBuilderBucket
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class PROOF_VALUE:
        value: ManifestBuilderProof
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class EXPRESSION_VALUE:
        value: ManifestExpression
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BLOB_VALUE:
        value: ManifestBlobRef
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class DECIMAL_VALUE:
        value: Decimal
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class PRECISE_DECIMAL_VALUE:
        value: PreciseDecimal
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class NON_FUNGIBLE_LOCAL_ID_VALUE:
        value: NonFungibleLocalId
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ADDRESS_RESERVATION_VALUE:
        value: ManifestBuilderAddressReservation
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_bool_value(self) -> bool: ...
    def is_i8_value(self) -> bool: ...
    def is_i16_value(self) -> bool: ...
    def is_i32_value(self) -> bool: ...
    def is_i64_value(self) -> bool: ...
    def is_i128_value(self) -> bool: ...
    def is_u8_value(self) -> bool: ...
    def is_u16_value(self) -> bool: ...
    def is_u32_value(self) -> bool: ...
    def is_u64_value(self) -> bool: ...
    def is_u128_value(self) -> bool: ...
    def is_string_value(self) -> bool: ...
    def is_enum_value(self) -> bool: ...
    def is_array_value(self) -> bool: ...
    def is_tuple_value(self) -> bool: ...
    def is_map_value(self) -> bool: ...
    def is_address_value(self) -> bool: ...
    def is_bucket_value(self) -> bool: ...
    def is_proof_value(self) -> bool: ...
    def is_expression_value(self) -> bool: ...
    def is_blob_value(self) -> bool: ...
    def is_decimal_value(self) -> bool: ...
    def is_precise_decimal_value(self) -> bool: ...
    def is_non_fungible_local_id_value(self) -> bool: ...
    def is_address_reservation_value(self) -> bool: ...

class _UniffiConverterTypeManifestBuilderValue(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ManifestBuilderValueKind(enum.Enum):
    BOOL_VALUE: int = ...
    I8_VALUE: int = ...
    I16_VALUE: int = ...
    I32_VALUE: int = ...
    I64_VALUE: int = ...
    I128_VALUE: int = ...
    U8_VALUE: int = ...
    U16_VALUE: int = ...
    U32_VALUE: int = ...
    U64_VALUE: int = ...
    U128_VALUE: int = ...
    STRING_VALUE: int = ...
    ENUM_VALUE: int = ...
    ARRAY_VALUE: int = ...
    TUPLE_VALUE: int = ...
    MAP_VALUE: int = ...
    ADDRESS_VALUE: int = ...
    BUCKET_VALUE: int = ...
    PROOF_VALUE: int = ...
    EXPRESSION_VALUE: int = ...
    BLOB_VALUE: int = ...
    DECIMAL_VALUE: int = ...
    PRECISE_DECIMAL_VALUE: int = ...
    NON_FUNGIBLE_LOCAL_ID_VALUE: int = ...
    ADDRESS_RESERVATION_VALUE: int = ...

class _UniffiConverterTypeManifestBuilderValueKind(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ManifestClass(enum.Enum):
    GENERAL: int = ...
    TRANSFER: int = ...
    POOL_CONTRIBUTION: int = ...
    POOL_REDEMPTION: int = ...
    VALIDATOR_STAKE: int = ...
    VALIDATOR_UNSTAKE: int = ...
    VALIDATOR_CLAIM: int = ...
    ACCOUNT_DEPOSIT_SETTINGS_UPDATE: int = ...

class _UniffiConverterTypeManifestClass(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ManifestExpression(enum.Enum):
    ENTIRE_WORKTOP: int = ...
    ENTIRE_AUTH_ZONE: int = ...

class _UniffiConverterTypeManifestExpression(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ManifestSborStringRepresentation:
    def __init__(self) -> None: ...

    class MANIFEST_STRING:
        def __init__(self) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class JSON:
        value: SerializationMode
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_manifest_string(self) -> bool: ...
    def is_json(self) -> bool: ...

class _UniffiConverterTypeManifestSborStringRepresentation(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ManifestValue:
    def __init__(self) -> None: ...

    class BOOL_VALUE:
        value: bool
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class I8_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class I16_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class I32_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class I64_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class I128_VALUE:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U8_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U16_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U32_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U64_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U128_VALUE:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class STRING_VALUE:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ENUM_VALUE:
        discriminator: int
        fields: typing.List[ManifestValue]
        def __init__(self, discriminator: Any, fields: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ARRAY_VALUE:
        element_value_kind: ManifestValueKind
        elements: typing.List[ManifestValue]
        def __init__(self, element_value_kind: Any, elements: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class TUPLE_VALUE:
        fields: typing.List[ManifestValue]
        def __init__(self, fields: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class MAP_VALUE:
        key_value_kind: ManifestValueKind
        value_value_kind: ManifestValueKind
        entries: typing.List[MapEntry]
        def __init__(
            self, key_value_kind: Any, value_value_kind: Any, entries: Any
        ) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ADDRESS_VALUE:
        value: ManifestAddress
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BUCKET_VALUE:
        value: ManifestBucket
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class PROOF_VALUE:
        value: ManifestProof
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class EXPRESSION_VALUE:
        value: ManifestExpression
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BLOB_VALUE:
        value: ManifestBlobRef
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class DECIMAL_VALUE:
        value: Decimal
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class PRECISE_DECIMAL_VALUE:
        value: PreciseDecimal
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class NON_FUNGIBLE_LOCAL_ID_VALUE:
        value: NonFungibleLocalId
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ADDRESS_RESERVATION_VALUE:
        value: ManifestAddressReservation
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_bool_value(self) -> bool: ...
    def is_i8_value(self) -> bool: ...
    def is_i16_value(self) -> bool: ...
    def is_i32_value(self) -> bool: ...
    def is_i64_value(self) -> bool: ...
    def is_i128_value(self) -> bool: ...
    def is_u8_value(self) -> bool: ...
    def is_u16_value(self) -> bool: ...
    def is_u32_value(self) -> bool: ...
    def is_u64_value(self) -> bool: ...
    def is_u128_value(self) -> bool: ...
    def is_string_value(self) -> bool: ...
    def is_enum_value(self) -> bool: ...
    def is_array_value(self) -> bool: ...
    def is_tuple_value(self) -> bool: ...
    def is_map_value(self) -> bool: ...
    def is_address_value(self) -> bool: ...
    def is_bucket_value(self) -> bool: ...
    def is_proof_value(self) -> bool: ...
    def is_expression_value(self) -> bool: ...
    def is_blob_value(self) -> bool: ...
    def is_decimal_value(self) -> bool: ...
    def is_precise_decimal_value(self) -> bool: ...
    def is_non_fungible_local_id_value(self) -> bool: ...
    def is_address_reservation_value(self) -> bool: ...

class _UniffiConverterTypeManifestValue(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ManifestValueKind(enum.Enum):
    BOOL_VALUE: int = ...
    I8_VALUE: int = ...
    I16_VALUE: int = ...
    I32_VALUE: int = ...
    I64_VALUE: int = ...
    I128_VALUE: int = ...
    U8_VALUE: int = ...
    U16_VALUE: int = ...
    U32_VALUE: int = ...
    U64_VALUE: int = ...
    U128_VALUE: int = ...
    STRING_VALUE: int = ...
    ENUM_VALUE: int = ...
    ARRAY_VALUE: int = ...
    TUPLE_VALUE: int = ...
    MAP_VALUE: int = ...
    ADDRESS_VALUE: int = ...
    BUCKET_VALUE: int = ...
    PROOF_VALUE: int = ...
    EXPRESSION_VALUE: int = ...
    BLOB_VALUE: int = ...
    DECIMAL_VALUE: int = ...
    PRECISE_DECIMAL_VALUE: int = ...
    NON_FUNGIBLE_LOCAL_ID_VALUE: int = ...
    ADDRESS_RESERVATION_VALUE: int = ...

class _UniffiConverterTypeManifestValueKind(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class Message:
    def __init__(self) -> None: ...

    class NONE:
        def __init__(self) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class PLAIN_TEXT:
        value: PlainTextMessage
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ENCRYPTED:
        value: EncryptedMessage
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_none(self) -> bool: ...
    def is_plain_text(self) -> bool: ...
    def is_encrypted(self) -> bool: ...

class _UniffiConverterTypeMessage(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class MessageContent:
    def __init__(self) -> None: ...

    class STR:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BYTES:
        value: bytes
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_str(self) -> bool: ...
    def is_bytes(self) -> bool: ...

class _UniffiConverterTypeMessageContent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class MetadataValue:
    def __init__(self) -> None: ...

    class STRING_VALUE:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BOOL_VALUE:
        value: bool
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U8_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U32_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U64_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class I32_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class I64_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class DECIMAL_VALUE:
        value: Decimal
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class GLOBAL_ADDRESS_VALUE:
        value: Address
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class PUBLIC_KEY_VALUE:
        value: PublicKey
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class NON_FUNGIBLE_GLOBAL_ID_VALUE:
        value: NonFungibleGlobalId
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class NON_FUNGIBLE_LOCAL_ID_VALUE:
        value: NonFungibleLocalId
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class INSTANT_VALUE:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class URL_VALUE:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ORIGIN_VALUE:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class PUBLIC_KEY_HASH_VALUE:
        value: PublicKeyHash
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class STRING_ARRAY_VALUE:
        value: typing.List[str]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BOOL_ARRAY_VALUE:
        value: typing.List[bool]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U8_ARRAY_VALUE:
        value: bytes
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U32_ARRAY_VALUE:
        value: typing.List[int]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class U64_ARRAY_VALUE:
        value: typing.List[int]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class I32_ARRAY_VALUE:
        value: typing.List[int]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class I64_ARRAY_VALUE:
        value: typing.List[int]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class DECIMAL_ARRAY_VALUE:
        value: typing.List[Decimal]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class GLOBAL_ADDRESS_ARRAY_VALUE:
        value: typing.List[Address]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class PUBLIC_KEY_ARRAY_VALUE:
        value: typing.List[PublicKey]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class NON_FUNGIBLE_GLOBAL_ID_ARRAY_VALUE:
        value: typing.List[NonFungibleGlobalId]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class NON_FUNGIBLE_LOCAL_ID_ARRAY_VALUE:
        value: typing.List[NonFungibleLocalId]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class INSTANT_ARRAY_VALUE:
        value: typing.List[int]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class URL_ARRAY_VALUE:
        value: typing.List[str]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ORIGIN_ARRAY_VALUE:
        value: typing.List[str]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class PUBLIC_KEY_HASH_ARRAY_VALUE:
        value: typing.List[PublicKeyHash]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_string_value(self) -> bool: ...
    def is_bool_value(self) -> bool: ...
    def is_u8_value(self) -> bool: ...
    def is_u32_value(self) -> bool: ...
    def is_u64_value(self) -> bool: ...
    def is_i32_value(self) -> bool: ...
    def is_i64_value(self) -> bool: ...
    def is_decimal_value(self) -> bool: ...
    def is_global_address_value(self) -> bool: ...
    def is_public_key_value(self) -> bool: ...
    def is_non_fungible_global_id_value(self) -> bool: ...
    def is_non_fungible_local_id_value(self) -> bool: ...
    def is_instant_value(self) -> bool: ...
    def is_url_value(self) -> bool: ...
    def is_origin_value(self) -> bool: ...
    def is_public_key_hash_value(self) -> bool: ...
    def is_string_array_value(self) -> bool: ...
    def is_bool_array_value(self) -> bool: ...
    def is_u8_array_value(self) -> bool: ...
    def is_u32_array_value(self) -> bool: ...
    def is_u64_array_value(self) -> bool: ...
    def is_i32_array_value(self) -> bool: ...
    def is_i64_array_value(self) -> bool: ...
    def is_decimal_array_value(self) -> bool: ...
    def is_global_address_array_value(self) -> bool: ...
    def is_public_key_array_value(self) -> bool: ...
    def is_non_fungible_global_id_array_value(self) -> bool: ...
    def is_non_fungible_local_id_array_value(self) -> bool: ...
    def is_instant_array_value(self) -> bool: ...
    def is_url_array_value(self) -> bool: ...
    def is_origin_array_value(self) -> bool: ...
    def is_public_key_hash_array_value(self) -> bool: ...

class _UniffiConverterTypeMetadataValue(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ModuleId(enum.Enum):
    MAIN: int = ...
    METADATA: int = ...
    ROYALTY: int = ...
    ROLE_ASSIGNMENT: int = ...

class _UniffiConverterTypeModuleId(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class NameRecordError:
    def __init__(self) -> None: ...

    class OBJECT_NAME_IS_ALREADY_TAKEN:
        object: str
        name: str
        def __init__(self, object: Any, name: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class OBJECT_DOES_NOT_EXIST:
        object: str
        name: str
        def __init__(self, object: Any, name: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_object_name_is_already_taken(self) -> bool: ...
    def is_object_does_not_exist(self) -> bool: ...

class _UniffiConverterTypeNameRecordError(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class NonFungibleLocalId:
    def __init__(self) -> None: ...

    class INTEGER:
        value: int
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class STR:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BYTES:
        value: bytes
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class RUID:
        value: bytes
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_integer(self) -> bool: ...
    def is_str(self) -> bool: ...
    def is_bytes(self) -> bool: ...
    def is_ruid(self) -> bool: ...

class _UniffiConverterTypeNonFungibleLocalId(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class NonFungibleResourceIndicator:
    def __init__(self) -> None: ...

    class BY_ALL:
        predicted_amount: PredictedDecimal
        predicted_ids: PredictedNonFungibleIds
        def __init__(self, predicted_amount: Any, predicted_ids: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BY_AMOUNT:
        amount: Decimal
        predicted_ids: PredictedNonFungibleIds
        def __init__(self, amount: Any, predicted_ids: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BY_IDS:
        ids: typing.List[NonFungibleLocalId]
        def __init__(self, ids: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_by_all(self) -> bool: ...
    def is_by_amount(self) -> bool: ...
    def is_by_ids(self) -> bool: ...

class _UniffiConverterTypeNonFungibleResourceIndicator(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class OlympiaNetwork(enum.Enum):
    MAINNET: int = ...
    STOKENET: int = ...
    RELEASENET: int = ...
    RC_NET: int = ...
    MILESTONENET: int = ...
    DEVOPSNET: int = ...
    SANDPITNET: int = ...
    LOCALNET: int = ...

class _UniffiConverterTypeOlympiaNetwork(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class Operation(enum.Enum):
    ADD: int = ...
    REMOVE: int = ...

class _UniffiConverterTypeOperation(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class OwnerRole:
    def __init__(self) -> None: ...

    class NONE:
        def __init__(self) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class FIXED:
        value: AccessRule
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class UPDATABLE:
        value: AccessRule
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_none(self) -> bool: ...
    def is_fixed(self) -> bool: ...
    def is_updatable(self) -> bool: ...

class _UniffiConverterTypeOwnerRole(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class Proposer(enum.Enum):
    PRIMARY: int = ...
    RECOVERY: int = ...

class _UniffiConverterTypeProposer(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class PublicKey:
    def __init__(self) -> None: ...

    class SECP256K1:
        value: bytes
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ED25519:
        value: bytes
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_secp256k1(self) -> bool: ...
    def is_ed25519(self) -> bool: ...

class _UniffiConverterTypePublicKey(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class PublicKeyHash:
    def __init__(self) -> None: ...

    class SECP256K1:
        value: bytes
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ED25519:
        value: bytes
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_secp256k1(self) -> bool: ...
    def is_ed25519(self) -> bool: ...

class _UniffiConverterTypePublicKeyHash(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class RadixEngineToolkitError(Exception): ...

class RadixEngineToolkitError:
    class InvalidLength(_UniffiTempRadixEngineToolkitError):
        expected: Any = ...
        actual: Any = ...
        data: Any = ...
        def __init__(self, expected: Any, actual: Any, data: Any) -> None: ...

    class FailedToExtractNetwork(_UniffiTempRadixEngineToolkitError):
        address: Any = ...
        def __init__(self, address: Any) -> None: ...

    class Bech32DecodeError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class ParseError(_UniffiTempRadixEngineToolkitError):
        type_name: Any = ...
        error: Any = ...
        def __init__(self, type_name: Any, error: Any) -> None: ...

    class NonFungibleContentValidationError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class EntityTypeMismatchError(_UniffiTempRadixEngineToolkitError):
        expected: Any = ...
        actual: Any = ...
        def __init__(self, expected: Any, actual: Any) -> None: ...

    class DerivationError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class InvalidPublicKey(_UniffiTempRadixEngineToolkitError):
        def __init__(self) -> None: ...

    class CompileError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class DecompileError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class PrepareError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class EncodeError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class DecodeError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class TransactionValidationFailed(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class ExecutionModuleError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class ManifestSborError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class ScryptoSborError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class TypedNativeEventError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class FailedToDecodeTransactionHash(_UniffiTempRadixEngineToolkitError):
        def __init__(self) -> None: ...

    class ManifestBuilderNameRecordError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class ManifestModificationError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class InvalidEntityTypeIdError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class DecimalError(_UniffiTempRadixEngineToolkitError):
        def __init__(self) -> None: ...

    class SignerError(_UniffiTempRadixEngineToolkitError):
        error: Any = ...
        def __init__(self, error: Any) -> None: ...

    class InvalidReceipt(_UniffiTempRadixEngineToolkitError):
        def __init__(self) -> None: ...

class _UniffiConverterTypeRadixEngineToolkitError(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    @staticmethod
    def write(value: Any, buf: Any) -> None: ...

class RecallResourceEvent:
    def __init__(self) -> None: ...

    class AMOUNT:
        value: Decimal
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class IDS:
        value: typing.List[NonFungibleLocalId]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_amount(self) -> bool: ...
    def is_ids(self) -> bool: ...

class _UniffiConverterTypeRecallResourceEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ReservedInstruction(enum.Enum):
    ACCOUNT_LOCK_FEE: int = ...
    ACCOUNT_SECURIFY: int = ...
    IDENTITY_SECURIFY: int = ...
    ACCOUNT_UPDATE_SETTINGS: int = ...
    ACCESS_CONTROLLER_METHOD: int = ...

class _UniffiConverterTypeReservedInstruction(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ResourceIndicator:
    def __init__(self) -> None: ...

    class FUNGIBLE:
        resource_address: Address
        indicator: FungibleResourceIndicator
        def __init__(self, resource_address: Any, indicator: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class NON_FUNGIBLE:
        resource_address: Address
        indicator: NonFungibleResourceIndicator
        def __init__(self, resource_address: Any, indicator: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_fungible(self) -> bool: ...
    def is_non_fungible(self) -> bool: ...

class _UniffiConverterTypeResourceIndicator(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ResourceOrNonFungible:
    def __init__(self) -> None: ...

    class NON_FUNGIBLE:
        value: NonFungibleGlobalId
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class RESOURCE:
        value: Address
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_non_fungible(self) -> bool: ...
    def is_resource(self) -> bool: ...

class _UniffiConverterTypeResourceOrNonFungible(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ResourcePreference(enum.Enum):
    ALLOWED: int = ...
    DISALLOWED: int = ...

class _UniffiConverterTypeResourcePreference(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ResourcePreferenceUpdate:
    def __init__(self) -> None: ...

    class SET:
        value: ResourcePreference
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class REMOVE:
        def __init__(self) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_set(self) -> bool: ...
    def is_remove(self) -> bool: ...

class _UniffiConverterTypeResourcePreferenceUpdate(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ResourceSpecifier:
    def __init__(self) -> None: ...

    class AMOUNT:
        resource_address: Address
        amount: Decimal
        def __init__(self, resource_address: Any, amount: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class IDS:
        resource_address: Address
        ids: typing.List[NonFungibleLocalId]
        def __init__(self, resource_address: Any, ids: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_amount(self) -> bool: ...
    def is_ids(self) -> bool: ...

class _UniffiConverterTypeResourceSpecifier(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class Role(enum.Enum):
    PRIMARY: int = ...
    RECOVERY: int = ...
    CONFIRMATION: int = ...

class _UniffiConverterTypeRole(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class RoundingMode(enum.Enum):
    TO_POSITIVE_INFINITY: int = ...
    TO_NEGATIVE_INFINITY: int = ...
    TO_ZERO: int = ...
    AWAY_FROM_ZERO: int = ...
    TO_NEAREST_MIDPOINT_TOWARD_ZERO: int = ...
    TO_NEAREST_MIDPOINT_AWAY_FROM_ZERO: int = ...
    TO_NEAREST_MIDPOINT_TO_EVEN: int = ...

class _UniffiConverterTypeRoundingMode(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class RoyaltyAmount:
    def __init__(self) -> None: ...

    class FREE:
        def __init__(self) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class XRD:
        value: Decimal
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class USD:
        value: Decimal
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_free(self) -> bool: ...
    def is_xrd(self) -> bool: ...
    def is_usd(self) -> bool: ...

class _UniffiConverterTypeRoyaltyAmount(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ScryptoSborString:
    def __init__(self) -> None: ...

    class PROGRAMMATIC_JSON:
        value: str
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_programmatic_json(self) -> bool: ...

class _UniffiConverterTypeScryptoSborString(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class SerializationMode(enum.Enum):
    PROGRAMMATIC: int = ...
    NATURAL: int = ...

class _UniffiConverterTypeSerializationMode(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class Signature:
    def __init__(self) -> None: ...

    class SECP256K1:
        value: bytes
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ED25519:
        value: bytes
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_secp256k1(self) -> bool: ...
    def is_ed25519(self) -> bool: ...

class _UniffiConverterTypeSignature(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class SignatureWithPublicKey:
    def __init__(self) -> None: ...

    class SECP256K1:
        signature: bytes
        def __init__(self, signature: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ED25519:
        signature: bytes
        public_key: bytes
        def __init__(self, signature: Any, public_key: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_secp256k1(self) -> bool: ...
    def is_ed25519(self) -> bool: ...

class _UniffiConverterTypeSignatureWithPublicKey(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedAccessControllerBlueprintEvent:
    def __init__(self) -> None: ...

    class INITIATE_RECOVERY_EVENT_VALUE:
        value: InitiateRecoveryEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class INITIATE_BADGE_WITHDRAW_ATTEMPT_EVENT_VALUE:
        value: InitiateBadgeWithdrawAttemptEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class RULE_SET_UPDATE_EVENT_VALUE:
        value: RuleSetUpdateEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BADGE_WITHDRAW_EVENT_VALUE:
        value: BadgeWithdrawEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CANCEL_RECOVERY_PROPOSAL_EVENT_VALUE:
        value: CancelRecoveryProposalEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CANCEL_BADGE_WITHDRAW_ATTEMPT_EVENT_VALUE:
        value: CancelBadgeWithdrawAttemptEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class LOCK_PRIMARY_ROLE_EVENT_VALUE:
        value: LockPrimaryRoleEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class UNLOCK_PRIMARY_ROLE_EVENT_VALUE:
        value: UnlockPrimaryRoleEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class STOP_TIMED_RECOVERY_EVENT_VALUE:
        value: StopTimedRecoveryEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_initiate_recovery_event_value(self) -> bool: ...
    def is_initiate_badge_withdraw_attempt_event_value(self) -> bool: ...
    def is_rule_set_update_event_value(self) -> bool: ...
    def is_badge_withdraw_event_value(self) -> bool: ...
    def is_cancel_recovery_proposal_event_value(self) -> bool: ...
    def is_cancel_badge_withdraw_attempt_event_value(self) -> bool: ...
    def is_lock_primary_role_event_value(self) -> bool: ...
    def is_unlock_primary_role_event_value(self) -> bool: ...
    def is_stop_timed_recovery_event_value(self) -> bool: ...

class _UniffiConverterTypeTypedAccessControllerBlueprintEvent(
    _UniffiConverterRustBuffer
):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedAccessControllerPackageEvent:
    def __init__(self) -> None: ...

    class ACCESS_CONTROLLER:
        value: TypedAccessControllerBlueprintEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_access_controller(self) -> bool: ...

class _UniffiConverterTypeTypedAccessControllerPackageEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedAccountBlueprintEvent:
    def __init__(self) -> None: ...

    class ACCOUNT_WITHDRAW_EVENT_VALUE:
        value: AccountWithdrawEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ACCOUNT_DEPOSIT_EVENT_VALUE:
        value: AccountDepositEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ACCOUNT_REJECTED_DEPOSIT_EVENT_VALUE:
        value: AccountRejectedDepositEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ACCOUNT_SET_RESOURCE_PREFERENCE_EVENT_VALUE:
        value: AccountSetResourcePreferenceEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ACCOUNT_REMOVE_RESOURCE_PREFERENCE_EVENT_VALUE:
        value: AccountRemoveResourcePreferenceEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ACCOUNT_SET_DEFAULT_DEPOSIT_RULE_EVENT_VALUE:
        value: AccountSetDefaultDepositRuleEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ACCOUNT_ADD_AUTHORIZED_DEPOSITOR_EVENT_VALUE:
        value: AccountAddAuthorizedDepositorEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ACCOUNT_REMOVE_AUTHORIZED_DEPOSITOR_EVENT_VALUE:
        value: AccountRemoveAuthorizedDepositorEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_account_withdraw_event_value(self) -> bool: ...
    def is_account_deposit_event_value(self) -> bool: ...
    def is_account_rejected_deposit_event_value(self) -> bool: ...
    def is_account_set_resource_preference_event_value(self) -> bool: ...
    def is_account_remove_resource_preference_event_value(self) -> bool: ...
    def is_account_set_default_deposit_rule_event_value(self) -> bool: ...
    def is_account_add_authorized_depositor_event_value(self) -> bool: ...
    def is_account_remove_authorized_depositor_event_value(self) -> bool: ...

class _UniffiConverterTypeTypedAccountBlueprintEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedAccountPackageEvent:
    def __init__(self) -> None: ...

    class ACCOUNT:
        value: TypedAccountBlueprintEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_account(self) -> bool: ...

class _UniffiConverterTypeTypedAccountPackageEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedConsensusManagerBlueprintEvent:
    def __init__(self) -> None: ...

    class ROUND_CHANGE_EVENT_VALUE:
        value: RoundChangeEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class EPOCH_CHANGE_EVENT_VALUE:
        value: EpochChangeEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_round_change_event_value(self) -> bool: ...
    def is_epoch_change_event_value(self) -> bool: ...

class _UniffiConverterTypeTypedConsensusManagerBlueprintEvent(
    _UniffiConverterRustBuffer
):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedConsensusManagerPackageEvent:
    def __init__(self) -> None: ...

    class CONSENSUS_MANAGER:
        value: TypedConsensusManagerBlueprintEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class VALIDATOR:
        value: TypedValidatorBlueprintEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_consensus_manager(self) -> bool: ...
    def is_validator(self) -> bool: ...

class _UniffiConverterTypeTypedConsensusManagerPackageEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedFungibleResourceManagerBlueprintEvent:
    def __init__(self) -> None: ...

    class VAULT_CREATION_EVENT_VALUE:
        value: VaultCreationEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class MINT_FUNGIBLE_RESOURCE_EVENT_VALUE:
        value: MintFungibleResourceEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BURN_FUNGIBLE_RESOURCE_EVENT_VALUE:
        value: BurnFungibleResourceEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_vault_creation_event_value(self) -> bool: ...
    def is_mint_fungible_resource_event_value(self) -> bool: ...
    def is_burn_fungible_resource_event_value(self) -> bool: ...

class _UniffiConverterTypeTypedFungibleResourceManagerBlueprintEvent(
    _UniffiConverterRustBuffer
):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedFungibleVaultBlueprintEvent:
    def __init__(self) -> None: ...

    class FUNGIBLE_VAULT_LOCK_FEE_EVENT_VALUE:
        value: FungibleVaultLockFeeEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class FUNGIBLE_VAULT_WITHDRAW_EVENT_VALUE:
        value: FungibleVaultWithdrawEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class FUNGIBLE_VAULT_DEPOSIT_EVENT_VALUE:
        value: FungibleVaultDepositEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class FUNGIBLE_VAULT_RECALL_EVENT_VALUE:
        value: FungibleVaultRecallEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class FUNGIBLE_VAULT_PAY_FEE_EVENT_VALUE:
        value: FungibleVaultPayFeeEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_fungible_vault_lock_fee_event_value(self) -> bool: ...
    def is_fungible_vault_withdraw_event_value(self) -> bool: ...
    def is_fungible_vault_deposit_event_value(self) -> bool: ...
    def is_fungible_vault_recall_event_value(self) -> bool: ...
    def is_fungible_vault_pay_fee_event_value(self) -> bool: ...

class _UniffiConverterTypeTypedFungibleVaultBlueprintEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedMetadataBlueprintEvent:
    def __init__(self) -> None: ...

    class SET_METADATA_EVENT_VALUE:
        value: SetMetadataEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class REMOVE_METADATA_EVENT_VALUE:
        value: RemoveMetadataEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_set_metadata_event_value(self) -> bool: ...
    def is_remove_metadata_event_value(self) -> bool: ...

class _UniffiConverterTypeTypedMetadataBlueprintEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedMetadataPackageEvent:
    def __init__(self) -> None: ...

    class METADATA:
        value: TypedMetadataBlueprintEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_metadata(self) -> bool: ...

class _UniffiConverterTypeTypedMetadataPackageEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedMultiResourcePoolBlueprintEvent:
    def __init__(self) -> None: ...

    class MULTI_RESOURCE_POOL_CONTRIBUTION_EVENT_VALUE:
        value: MultiResourcePoolContributionEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class MULTI_RESOURCE_POOL_REDEMPTION_EVENT_VALUE:
        value: MultiResourcePoolRedemptionEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class MULTI_RESOURCE_POOL_WITHDRAW_EVENT_VALUE:
        value: MultiResourcePoolWithdrawEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class MULTI_RESOURCE_POOL_DEPOSIT_EVENT_VALUE:
        value: MultiResourcePoolDepositEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_multi_resource_pool_contribution_event_value(self) -> bool: ...
    def is_multi_resource_pool_redemption_event_value(self) -> bool: ...
    def is_multi_resource_pool_withdraw_event_value(self) -> bool: ...
    def is_multi_resource_pool_deposit_event_value(self) -> bool: ...

class _UniffiConverterTypeTypedMultiResourcePoolBlueprintEvent(
    _UniffiConverterRustBuffer
):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedNativeEvent:
    def __init__(self) -> None: ...

    class ACCESS_CONTROLLER:
        value: TypedAccessControllerPackageEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ACCOUNT:
        value: TypedAccountPackageEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CONSENSUS_MANAGER:
        value: TypedConsensusManagerPackageEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class POOL:
        value: TypedPoolPackageEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class RESOURCE:
        value: TypedResourcePackageEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ROLE_ASSIGNMENT:
        value: TypedRoleAssignmentPackageEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class METADATA:
        value: TypedMetadataPackageEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_access_controller(self) -> bool: ...
    def is_account(self) -> bool: ...
    def is_consensus_manager(self) -> bool: ...
    def is_pool(self) -> bool: ...
    def is_resource(self) -> bool: ...
    def is_role_assignment(self) -> bool: ...
    def is_metadata(self) -> bool: ...

class _UniffiConverterTypeTypedNativeEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedNonFungibleResourceManagerBlueprintEvent:
    def __init__(self) -> None: ...

    class VAULT_CREATION_EVENT_VALUE:
        value: VaultCreationEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class MINT_NON_FUNGIBLE_RESOURCE_EVENT_VALUE:
        value: MintNonFungibleResourceEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class BURN_NON_FUNGIBLE_RESOURCE_EVENT_VALUE:
        value: BurnNonFungibleResourceEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_vault_creation_event_value(self) -> bool: ...
    def is_mint_non_fungible_resource_event_value(self) -> bool: ...
    def is_burn_non_fungible_resource_event_value(self) -> bool: ...

class _UniffiConverterTypeTypedNonFungibleResourceManagerBlueprintEvent(
    _UniffiConverterRustBuffer
):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedNonFungibleVaultBlueprintEvent:
    def __init__(self) -> None: ...

    class NON_FUNGIBLE_VAULT_WITHDRAW_EVENT_VALUE:
        value: NonFungibleVaultWithdrawEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class NON_FUNGIBLE_VAULT_DEPOSIT_EVENT_VALUE:
        value: NonFungibleVaultDepositEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class NON_FUNGIBLE_VAULT_RECALL_EVENT_VALUE:
        value: NonFungibleVaultRecallEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_non_fungible_vault_withdraw_event_value(self) -> bool: ...
    def is_non_fungible_vault_deposit_event_value(self) -> bool: ...
    def is_non_fungible_vault_recall_event_value(self) -> bool: ...

class _UniffiConverterTypeTypedNonFungibleVaultBlueprintEvent(
    _UniffiConverterRustBuffer
):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedOneResourcePoolBlueprintEvent:
    def __init__(self) -> None: ...

    class ONE_RESOURCE_POOL_CONTRIBUTION_EVENT_VALUE:
        value: OneResourcePoolContributionEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ONE_RESOURCE_POOL_REDEMPTION_EVENT_VALUE:
        value: OneResourcePoolRedemptionEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ONE_RESOURCE_POOL_WITHDRAW_EVENT_VALUE:
        value: OneResourcePoolWithdrawEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ONE_RESOURCE_POOL_DEPOSIT_EVENT_VALUE:
        value: OneResourcePoolDepositEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_one_resource_pool_contribution_event_value(self) -> bool: ...
    def is_one_resource_pool_redemption_event_value(self) -> bool: ...
    def is_one_resource_pool_withdraw_event_value(self) -> bool: ...
    def is_one_resource_pool_deposit_event_value(self) -> bool: ...

class _UniffiConverterTypeTypedOneResourcePoolBlueprintEvent(
    _UniffiConverterRustBuffer
):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedPoolPackageEvent:
    def __init__(self) -> None: ...

    class ONE_RESOURCE_POOL:
        value: TypedOneResourcePoolBlueprintEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class TWO_RESOURCE_POOL:
        value: TypedTwoResourcePoolBlueprintEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class MULTI_RESOURCE_POOL:
        value: TypedMultiResourcePoolBlueprintEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_one_resource_pool(self) -> bool: ...
    def is_two_resource_pool(self) -> bool: ...
    def is_multi_resource_pool(self) -> bool: ...

class _UniffiConverterTypeTypedPoolPackageEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedResourcePackageEvent:
    def __init__(self) -> None: ...

    class FUNGIBLE_VAULT:
        value: TypedFungibleVaultBlueprintEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class NON_FUNGIBLE_VAULT:
        value: TypedNonFungibleVaultBlueprintEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class FUNGIBLE_RESOURCE_MANAGER:
        value: TypedFungibleResourceManagerBlueprintEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class NON_FUNGIBLE_RESOURCE_MANAGER:
        value: TypedNonFungibleResourceManagerBlueprintEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_fungible_vault(self) -> bool: ...
    def is_non_fungible_vault(self) -> bool: ...
    def is_fungible_resource_manager(self) -> bool: ...
    def is_non_fungible_resource_manager(self) -> bool: ...

class _UniffiConverterTypeTypedResourcePackageEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedRoleAssignmentBlueprintEvent:
    def __init__(self) -> None: ...

    class SET_ROLE_EVENT_VALUE:
        value: SetRoleEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class SET_OWNER_ROLE_EVENT_VALUE:
        value: SetOwnerRoleEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class LOCK_OWNER_ROLE_EVENT_VALUE:
        value: LockOwnerRoleEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_set_role_event_value(self) -> bool: ...
    def is_set_owner_role_event_value(self) -> bool: ...
    def is_lock_owner_role_event_value(self) -> bool: ...

class _UniffiConverterTypeTypedRoleAssignmentBlueprintEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedRoleAssignmentPackageEvent:
    def __init__(self) -> None: ...

    class ROLE_ASSIGNMENT:
        value: TypedRoleAssignmentBlueprintEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_role_assignment(self) -> bool: ...

class _UniffiConverterTypeTypedRoleAssignmentPackageEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedTwoResourcePoolBlueprintEvent:
    def __init__(self) -> None: ...

    class TWO_RESOURCE_POOL_CONTRIBUTION_EVENT_VALUE:
        value: TwoResourcePoolContributionEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class TWO_RESOURCE_POOL_REDEMPTION_EVENT_VALUE:
        value: TwoResourcePoolRedemptionEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class TWO_RESOURCE_POOL_WITHDRAW_EVENT_VALUE:
        value: TwoResourcePoolWithdrawEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class TWO_RESOURCE_POOL_DEPOSIT_EVENT_VALUE:
        value: TwoResourcePoolDepositEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_two_resource_pool_contribution_event_value(self) -> bool: ...
    def is_two_resource_pool_redemption_event_value(self) -> bool: ...
    def is_two_resource_pool_withdraw_event_value(self) -> bool: ...
    def is_two_resource_pool_deposit_event_value(self) -> bool: ...

class _UniffiConverterTypeTypedTwoResourcePoolBlueprintEvent(
    _UniffiConverterRustBuffer
):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class TypedValidatorBlueprintEvent:
    def __init__(self) -> None: ...

    class REGISTER_VALIDATOR_EVENT_VALUE:
        value: RegisterValidatorEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class UNREGISTER_VALIDATOR_EVENT_VALUE:
        value: UnregisterValidatorEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class STAKE_EVENT_VALUE:
        value: StakeEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class UNSTAKE_EVENT_VALUE:
        value: UnstakeEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class CLAIM_XRD_EVENT_VALUE:
        value: ClaimXrdEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class UPDATE_ACCEPTING_STAKE_DELEGATION_STATE_EVENT_VALUE:
        value: UpdateAcceptingStakeDelegationStateEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class PROTOCOL_UPDATE_READINESS_SIGNAL_EVENT_VALUE:
        value: ProtocolUpdateReadinessSignalEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class VALIDATOR_EMISSION_APPLIED_EVENT_VALUE:
        value: ValidatorEmissionAppliedEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class VALIDATOR_REWARD_APPLIED_EVENT_VALUE:
        value: ValidatorRewardAppliedEvent
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_register_validator_event_value(self) -> bool: ...
    def is_unregister_validator_event_value(self) -> bool: ...
    def is_stake_event_value(self) -> bool: ...
    def is_unstake_event_value(self) -> bool: ...
    def is_claim_xrd_event_value(self) -> bool: ...
    def is_update_accepting_stake_delegation_state_event_value(self) -> bool: ...
    def is_protocol_update_readiness_signal_event_value(self) -> bool: ...
    def is_validator_emission_applied_event_value(self) -> bool: ...
    def is_validator_reward_applied_event_value(self) -> bool: ...

class _UniffiConverterTypeTypedValidatorBlueprintEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class WithdrawResourceEvent:
    def __init__(self) -> None: ...

    class AMOUNT:
        value: Decimal
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class IDS:
        value: typing.List[NonFungibleLocalId]
        def __init__(self, value: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_amount(self) -> bool: ...
    def is_ids(self) -> bool: ...

class _UniffiConverterTypeWithdrawResourceEvent(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class WithdrawStrategy:
    def __init__(self) -> None: ...

    class EXACT:
        def __init__(self) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    class ROUNDED:
        rounding_mode: RoundingMode
        def __init__(self, rounding_mode: Any) -> None: ...
        def __eq__(self, other: Any) -> Any: ...

    def is_exact(self) -> bool: ...
    def is_rounded(self) -> bool: ...

class _UniffiConverterTypeWithdrawStrategy(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf: Any): ...
    def write(value: Any, buf: Any) -> None: ...

class ConcurrentHandleMap:
    def __init__(self) -> None: ...
    def insert(self, obj: Any): ...
    def get(self, handle: Any): ...
    def remove(self, handle: Any): ...

class _UniffiConverterCallbackInterface:
    def __init__(self, cb: Any) -> None: ...
    def drop(self, handle: Any) -> None: ...
    @classmethod
    def lift(cls, handle: Any): ...
    @classmethod
    def read(cls, buf: Any) -> None: ...
    @classmethod
    def lower(cls, cb: Any): ...
    @classmethod
    def write(cls, cb: Any, buf: Any) -> None: ...

class Signer:
    def sign(self, hash: Hash) -> Any: ...
    def sign_to_signature(self, hash: Hash) -> Any: ...
    def sign_to_signature_with_public_key(self, hash: Hash) -> Any: ...
    def public_key(self) -> None: ...

class _UniffiConverterOptionalUInt32(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterOptionalTypeAccessRule(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterOptionalTypeDecimal(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterOptionalTypePreciseDecimal(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterOptionalTypeLockFeeModification(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterOptionalTypeManifestBuilderAddressReservation(
    _UniffiConverterRustBuffer
):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterOptionalTypeResourceManagerRole(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterOptionalTypeSchema(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterOptionalTypeMetadataValue(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterOptionalTypeResourceOrNonFungible(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceUInt32(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceInt32(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceUInt64(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceInt64(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceBool(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceString(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceBytes(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeAddress(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeDecimal(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeNonFungibleGlobalId(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeIndexedAssertion(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeManifestBuilderBucket(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeManifestBuilderMapEntry(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeMapEntry(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeTrackedPoolContribution(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeTrackedPoolRedemption(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeTrackedValidatorClaim(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeTrackedValidatorStake(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeTrackedValidatorUnstake(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeUnstakeDataEntry(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeDetailedManifestClass(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeEntityType(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeInstruction(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeManifestBuilderValue(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeManifestClass(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeManifestValue(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeNonFungibleLocalId(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypePublicKey(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypePublicKeyHash(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeReservedInstruction(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeResourceIndicator(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeResourceOrNonFungible(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterSequenceTypeSignatureWithPublicKey(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, value: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterMapStringTypeDecimal(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, items: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterMapStringTypeMetadataInitEntry(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, items: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterMapStringTypeValidatorInfo(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, items: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterMapStringTypeAccountDefaultDepositRule(
    _UniffiConverterRustBuffer
):
    @classmethod
    def write(cls, items: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterMapStringTypeResourcePreferenceUpdate(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, items: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterMapStringOptionalTypeAccessRule(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, items: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterMapStringOptionalTypeMetadataValue(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, items: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterMapStringSequenceTypeResourceIndicator(
    _UniffiConverterRustBuffer
):
    @classmethod
    def write(cls, items: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterMapStringSequenceTypeResourceOrNonFungible(
    _UniffiConverterRustBuffer
):
    @classmethod
    def write(cls, items: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterMapStringMapStringTypeResourcePreferenceUpdate(
    _UniffiConverterRustBuffer
):
    @classmethod
    def write(cls, items: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterMapStringMapStringOptionalTypeMetadataValue(
    _UniffiConverterRustBuffer
):
    @classmethod
    def write(cls, items: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterMapBytesBytes(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, items: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterMapTypeCurveTypeTypeDecryptorsByCurve(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, items: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

class _UniffiConverterMapTypeEntityTypeSequenceTypeAddress(_UniffiConverterRustBuffer):
    @classmethod
    def write(cls, items: Any, buf: Any) -> None: ...
    @classmethod
    def read(cls, buf: Any): ...

def build_information() -> BuildInformation: ...
def derive_olympia_account_address_from_public_key(
    public_key: PublicKey, olympia_network: OlympiaNetwork
) -> OlympiaAddress: ...
def derive_public_key_from_olympia_account_address(
    olympia_resource_address: OlympiaAddress,
) -> PublicKey: ...
def derive_resource_address_from_olympia_resource_address(
    olympia_resource_address: OlympiaAddress, network_id: int
) -> Address: ...
def derive_virtual_account_address_from_olympia_account_address(
    olympia_account_address: OlympiaAddress, network_id: int
) -> Address: ...
def derive_virtual_account_address_from_public_key(
    public_key: PublicKey, network_id: int
) -> Address: ...
def derive_virtual_identity_address_from_public_key(
    public_key: PublicKey, network_id: int
) -> Address: ...
def derive_virtual_signature_non_fungible_global_id_from_public_key(
    public_key: PublicKey, network_id: int
) -> NonFungibleGlobalId: ...
def hash(data: bytes) -> Hash: ...
def known_addresses(network_id: int) -> KnownAddresses: ...
def manifest_sbor_decode_to_string_representation(
    bytes: bytes,
    representation: ManifestSborStringRepresentation,
    network_id: int,
    schema: typing.Optional[Schema],
) -> str: ...
def metadata_sbor_decode(bytes: bytes, network_id: int) -> MetadataValue: ...
def metadata_sbor_encode(value: MetadataValue) -> bytes: ...
def non_fungible_local_id_as_str(value: NonFungibleLocalId) -> str: ...
def non_fungible_local_id_from_str(string: str) -> NonFungibleLocalId: ...
def non_fungible_local_id_sbor_decode(bytes: bytes) -> NonFungibleLocalId: ...
def non_fungible_local_id_sbor_encode(value: NonFungibleLocalId) -> bytes: ...
def sbor_decode_to_string_representation(
    bytes: bytes,
    representation: SerializationMode,
    network_id: int,
    schema: typing.Optional[Schema],
) -> str: ...
def sbor_decode_to_typed_native_event(
    event_type_identifier: EventTypeIdentifier, event_data: bytes, network_id: int
) -> TypedNativeEvent: ...
def scrypto_sbor_decode_to_string_representation(
    bytes: bytes,
    representation: SerializationMode,
    network_id: int,
    schema: typing.Optional[Schema],
) -> str: ...
def scrypto_sbor_encode_string_representation(
    representation: ScryptoSborString,
) -> bytes: ...
def test_panic(message: str) -> Any: ...
